#### 46. 全排列

难度：中等

---

给定一个不含重复数字的数组 `nums` ，返回其 _所有可能的全排列_ 。你可以  **按任意顺序**  返回答案。

 **示例 1：** 

```
输入：nums = [1,2,3]
输出：[[1,2,3],[1,3,2],[2,1,3],[2,3,1],[3,1,2],[3,2,1]]
```

 **示例 2：** 

```
输入：nums = [0,1]
输出：[[0,1],[1,0]]
```

 **示例 3：** 

```
输入：nums = [1]
输出：[[1]]
```

 **提示：** 

*   `1 <= nums.length <= 6`
*   `-10 <= nums[i] <= 10`
*   `nums` 中的所有整数  **互不相同**

---

回溯：

需要一个辅助数组记录是否已经被回溯过。复杂度会比较高。

时间复杂度：$O(N!N)$，$N$ 为数组长度。

```Java
class Solution {
    public List<List<Integer>> permute(int[] nums) {
        int n = nums.length;
        boolean[] visited = new boolean[n];
        List<List<Integer>> res = new ArrayList<>();
        bactrack(nums, res, new ArrayList<Integer>(), visited);
        return res;
    }

    private void bactrack(int[] nums, List<List<Integer>> res, ArrayList<Integer> temp, boolean[] visited){
        if(temp.size() == visited.length){
            res.add(new ArrayList<>(temp));
            return;
        }
        for(int i = 0; i < visited.length; i++){
            if(visited[i] == true) continue;
            visited[i] = true;
            temp.add(nums[i]);
            bactrack(nums, res, temp, visited);
            visited[i] = false;
            temp.remove(temp.size() - 1);
        }

    }
}
```