#### 47. 全排列 II

难度：中等

---

给定一个可包含重复数字的序列 `nums` ，_**按任意顺序**_ 返回所有不重复的全排列。

 **示例 1：** 

```
输入：nums = [1,1,2]
输出：
[[1,1,2],
 [1,2,1],
 [2,1,1]]
```

 **示例 2：** 

```
输入：nums = [1,2,3]
输出：[[1,2,3],[1,3,2],[2,1,3],[2,3,1],[3,1,2],[3,2,1]]
```

 **提示：** 

*   `1 <= nums.length <= 8`
*   `-10 <= nums[i] <= 10`

---

回溯：

与[全排列](https://leetcode.cn/problems/permutations-ii/)不同的是，本题需要进行去重操作。具体见代码。

```Java
class Solution {
    public List<List<Integer>> permuteUnique(int[] nums) {
        Arrays.sort(nums);
        List<List<Integer>> res = new ArrayList<>();
        backtrace(nums, res, new ArrayList<Integer>(), new boolean[nums.length]);
        return res;
    }

    private void backtrace(int[] nums, List<List<Integer>> res, ArrayList<Integer> temp, boolean[] visited){
        if(nums.length == temp.size()){
            res.add(new ArrayList<>(temp));
            return;
        }
        for(int i = 0; i < nums.length; i++){
            if(visited[i] || (i > 0 && nums[i] == nums[i - 1] && !visited[i - 1])){	// 去重
                continue;
            }
            visited[i] = true;
            temp.add(nums[i]);
            backtrace(nums, res, temp, visited);
            visited[i] = false;
            temp.remove(temp.size() - 1);
        }
    }
}
```