#### 1339. 分裂二叉树的最大乘积

难度：中等

-------

给你一棵二叉树，它的根为 `root` 。请你删除 1 条边，使二叉树分裂成两棵子树，且它们子树和的乘积尽可能大。

由于答案可能会很大，请你将结果对 10^9 + 7 取模后再返回。

 **示例 1：** 

 **![](https://assets.leetcode-cn.com/aliyun-lc-upload/uploads/2020/02/02/sample_1_1699.png)** 

```
输入：root = [1,2,3,4,5,6]
输出：110
解释：删除红色的边，得到 2 棵子树，和分别为 11 和 10 。它们的乘积是 110 （11*10）
```

 **示例 2：** 

![](https://assets.leetcode-cn.com/aliyun-lc-upload/uploads/2020/02/02/sample_2_1699.png)

```
输入：root = [1,null,2,3,4,null,null,5,6]
输出：90
解释：移除红色的边，得到 2 棵子树，和分别是 15 和 6 。它们的乘积为 90 （15*6）
```

 **示例 3：** 

```
输入：root = [2,3,9,10,7,8,6,5,4,11,1]
输出：1025
```

 **示例 4：** 

```
输入：root = [1,1]
输出：1
```

 **提示：** 

*   每棵树最多有 `50000` 个节点，且至少有 `2` 个节点。
*   每个节点的值在 `[1, 10000]` 之间。

---

失败：

1.  `MOD = (int) 1e9 + 7` !!!!

2. 应该是 `return ans % MOD`，而不是在每一次取最大值的时候取余

3. 需要用到 MOD 的时候最好使用 `long` 类型


```java
class Solution {
    private static final int MOD = (int) 10e9 + 7;  // 低级错误！！！
    private int ans = 0, sum;
    public int maxProduct(TreeNode root) {
        sum = dfs(root);
        dfs2(root);
        return ans;
    }

    private int dfs(TreeNode root){
        if(root == null) return 0;
        return dfs(root.left) + dfs(root.right) +  root.val;
    }

    private void dfs2(TreeNode root){
        if(root == null) return;
        int temp = dfs(root);
        ans = Math.max(ans, ((sum - temp) * temp) % MOD);       // 不应该在此处取余
        dfs2(root.left);
        dfs2(root.right);
    }
}
```

失败：

1. 在递归中调用了递归，**嵌套的双重递归是十分消耗资源**的，从[这里](https://leetcode.cn/problems/maximum-product-of-splitted-binary-tree/solution/shi-gai-xiang-zui-da-hua-chu-shi-gen-jie-3cpw/)发现问题的。


```java
class Solution {
    private static final long MOD = (long) 1e9 + 7;
    private long ans = 0, sum;
    long test = 0;
    public int maxProduct(TreeNode root) {
        sum = dfs(root);
        dfs2(root);
        return (int) (ans % MOD);
    }

    private long dfs(TreeNode root){
        if(root == null) return 0;
        return dfs(root.left) + dfs(root.right) +  (long)root.val;
    }

    private void dfs2(TreeNode root){
        if(root == null) return;
        long temp = dfs(root);  // 双重递归，十分消耗资源！
        if(((sum - temp) * temp) % MOD > ans) test =  temp ;
        ans = Math.max(ans, ((sum - temp) * temp));
        dfs2(root.left);
        dfs2(root.right);
    }
}
```

成功：

补充一点，嵌套的双重递归是自顶向下，每个递归的节点又自顶向下递归一遍，修改后的代码是自底向上的，每个结点只遍历一遍。

```java
class Solution {
    private static final long MOD = (long) 1e9 + 7;
    private long ans = 0, sum;
    long test = 0;
    public int maxProduct(TreeNode root) {
        sum = dfs(root);
        dfs2(root);
        return (int) (ans % MOD);
    }

    private long dfs(TreeNode root){
        if(root == null) return 0;
        return dfs(root.left) + dfs(root.right) +  (long)root.val;
    }

    private long dfs2(TreeNode root){
        if(root == null) return 0;
        long temp = dfs2(root.left) + dfs2(root.right) + root.val;
        ans = Math.max(ans, ((sum - temp) * temp));
        return temp;
    }
}
```