#### 784. 字母大小写全排列

难度：中等

---

给定一个字符串 `s` ，通过将字符串 `s` 中的每个字母转变大小写，我们可以获得一个新的字符串。

返回 _所有可能得到的字符串集合_ 。以  **任意顺序**  返回输出。

 **示例 1：** 

```
输入：s = "a1b2"
输出：["a1b2", "a1B2", "A1b2", "A1B2"]
```

 **示例 2:** 

```
输入: s = "3z4"
输出: ["3z4","3Z4"]
```

 **提示:** 

*   `1 <= s.length <= 12`
*   `s` 由小写英文字母、大写英文字母和数字组成

---

法一，深度优先搜索：

如果当前字符是字母，则变换大小写再调用本身。

```Java
class Solution {
    public List<String> letterCasePermutation(String s) {
        List<String> res = new ArrayList<>();
        dfs(res, new StringBuilder(), s);
        return res;
    }

    private void dfs(List<String> res, StringBuilder sb, String s){
        int index = sb.length();
        if(index == s.length()){
            res.add(sb.toString());
            return;
        }
        char c = s.charAt(index);
        dfs(res, new StringBuilder(sb).append(c), s);
        if(Character.isLetter(c)){
            c ^= ' ';	// 大小写转换，或与32异或也可以实现
            dfs(res, new StringBuilder(sb).append(c), s);
        }
        
    }
}
```

法二，回溯：

与法一类似，如果当前字符是字母，则大小写转换后回溯，同时回溯后需要将字母变换回来。

```java
class Solution {
    public List<String> letterCasePermutation(String s) {
        List<String> res = new ArrayList<>();
        backtrace(res, new StringBuilder(), s);
        return res;
    }

    private void backtrace(List<String> res, StringBuilder sb, String s){
        int index = sb.length();
        if(index == s.length()){
            res.add(sb.toString());
            return;
        }
        char c = s.charAt(index);
        if(Character.isLetter(c)){
            c ^= 32;
            backtrace(res, new StringBuilder(sb).append(c), s);
            c ^= 32;
        }
        backtrace(res, new StringBuilder(sb).append(c), s);
    }
}
```

