#### 162. 寻找峰值

难度：中等

---

峰值元素是指其值严格大于左右相邻值的元素。

给你一个整数数组 `nums`，找到峰值元素并返回其索引。数组可能包含多个峰值，在这种情况下，返回  **任何一个峰值**  所在位置即可。

你可以假设 `nums[-1] = nums[n] = -∞` 。

你必须实现时间复杂度为 `O(log n)` 的算法来解决此问题。

 **示例 1：** 

```
输入：nums = [1,2,3,1]
输出：2
解释：3 是峰值元素，你的函数应该返回其索引 2。
```

 **示例 2：** 

```
输入：nums = [1,2,1,3,5,6,4]
输出：1 或 5 
解释：你的函数可以返回索引 1，其峰值元素为 2；
     或者返回索引 5， 其峰值元素为 6。
```

 **提示：** 

*   `1 <= nums.length <= 1000`
*   `-2^31 <= nums[i] <= 2^31 - 1`
*   对于所有有效的 `i` 都有 `nums[i] != nums[i + 1]`

---

二分查找 + 爬坡理论：

> 如果我们从一个位置开始，不断地向高处走，那么最终一定可以到达一个峰值位置。

基于爬坡理论可以确定一点：

**如果当前元素不同于相邻元素时，那么沿着元素值递增的方向一定能找到一个峰值。**

```Java
class Solution {
    public int findPeakElement(int[] nums) {
        int left = 0, right = nums.length - 1;
        while(left <= right){
            int mid = (left + right) / 2;
            if(compareLeft(nums, mid) && compareRight(nums, mid)){
                return mid;
            } else if(compareLeft(nums, mid)) left = mid + 1;
            else right = mid - 1;
        }
        return -1;
    }

    private boolean compareLeft(int[] nums, int index){
        if(index == 0 || nums[index] > nums[index - 1]) return true;
        return false;
    }

    private boolean compareRight(int[] nums, int index){
        if(index == nums.length - 1 || nums[index] > nums[index + 1]) return true;
        return false;
    }
}
```