#### 2517. 礼盒的最大甜蜜度

难度：中等

---

给你一个正整数数组 `price` ，其中 `price[i]` 表示第 `i` 类糖果的价格，另给你一个正整数 `k` 。

商店组合 `k` 类  **不同**  糖果打包成礼盒出售。礼盒的  **甜蜜度**  是礼盒中任意两种糖果  **价格**  绝对差的最小值。

返回礼盒的  **最大**  甜蜜度_。_

 **示例 1：** 

```
输入：price = [13,5,1,8,21,2], k = 3
输出：8
解释：选出价格分别为 [13,5,21] 的三类糖果。
礼盒的甜蜜度为 min(|13 - 5|, |13 - 21|, |5 - 21|) = min(8, 8, 16) = 8 。
可以证明能够取得的最大甜蜜度就是 8 。
```

 **示例 2：** 

```
输入：price = [1,3,1], k = 2
输出：2
解释：选出价格分别为 [1,3] 的两类糖果。 
礼盒的甜蜜度为 min(|1 - 3|) = min(2) = 2 。
可以证明能够取得的最大甜蜜度就是 2 。
```

 **示例 3：** 

```
输入：price = [7,7,7,7], k = 2
输出：0
解释：从现有的糖果中任选两类糖果，甜蜜度都会是 0 。
```

 **提示：** 

*   `1 <= price.length <= 10^5`
*   `1 <= price[i] <= 10^9`
*   `2 <= k <= price.length`

---

贪心 + 二分查找：

将 `price` 数组排序，再以 `price[0]` 作为左端点，`price[n - 1] - price[0]` 作为右端点，不断寻找大于等于当前价格差的数组个数，若个数小于 `k`，意味着需要减少价格差，否则增加价格差。

```Java
class Solution {
    public int maximumTastiness(int[] price, int k) {
        int n = price.length;
        Arrays.sort(price);
        int left = 0, right = price[n - 1] - price[0];
        while(left <= right){
            int mid = (left + right) / 2;
            if(exist(price, k, mid)){
                left = mid + 1;
            } else {
                right = mid - 1;
            }
        }
        return left - 1;
    }

    public boolean exist(int[] price, int k, int target){
        int count = 1, pre = price[0];
        for(int i = 1; i < price.length; i++){
            if(price[i] - pre >= target){
                count ++;
                pre = price[i];
            }
        }
        return count >= k;
    }
}
```