#### 2594. 修车的最少时间

难度：中等

---

给你一个整数数组 `ranks` ，表示一些机械工的  **能力值**  。`ranksi` 是第 `i` 位机械工的能力值。能力值为 `r` 的机械工可以在 `r * n^2` 分钟内修好 `n` 辆车。

同时给你一个整数 `cars` ，表示总共需要修理的汽车数目。

请你返回修理所有汽车  **最少**  需要多少时间。

 **注意：** 所有机械工可以同时修理汽车。

 **示例 1：** 

```
输入：ranks = [4,2,3,1], cars = 10
输出：16
解释：
- 第一位机械工修 2 辆车，需要 4 * 2 * 2 = 16 分钟。
- 第二位机械工修 2 辆车，需要 2 * 2 * 2 = 8 分钟。
- 第三位机械工修 2 辆车，需要 3 * 2 * 2 = 12 分钟。
- 第四位机械工修 4 辆车，需要 1 * 4 * 4 = 16 分钟。
16 分钟是修理完所有车需要的最少时间。
```

 **示例 2：** 

```
输入：ranks = [5,1,8], cars = 6
输出：16
解释：
- 第一位机械工修 1 辆车，需要 5 * 1 * 1 = 5 分钟。
- 第二位机械工修 4 辆车，需要 1 * 4 * 4 = 16 分钟。
- 第三位机械工修 1 辆车，需要 8 * 1 * 1 = 8 分钟。
16 分钟时修理完所有车需要的最少时间。
```

 **提示：** 

*   `1 <= ranks.length <= 10^5`
*   `1 <= ranks[i] <= 100`
*   `1 <= cars <= 10^6`

---

二分查找：

按时间维度进行二分查找，上界可以取正无穷，也可以取任意一个工人修完所有车辆所需要的时间；下界取 `1`，最少需要的时间。如果 `t` 时间内完成修车任务，那么一定是所有工人一起工作。

```Java
class Solution {
    public long repairCars(int[] ranks, int cars) {
        long left = 1, right = 1l * ranks[0] * cars * cars;
        while(left <= right){
            long mid = (right - left) / 2 + left;
            if(check(ranks, cars, mid)){
                right = mid - 1;
            } else {
                left = mid + 1;
            }
        }
        return left;
    }

    private boolean check(int[] ranks, int cars, long time){
        long count = 0;
        for(int rank: ranks){
            count += (long) Math.sqrt(time / rank);
        }
        return count >= cars;
    }
}
```