#### 34. 在排序数组中查找元素的第一个和最后一个位置

难度：中等

---

给你一个按照非递减顺序排列的整数数组 `nums`，和一个目标值 `target`。请你找出给定目标值在数组中的开始位置和结束位置。

如果数组中不存在目标值 `target`，返回 `[-1, -1]`。

你必须设计并实现时间复杂度为 `O(log n)` 的算法解决此问题。

 **示例 1：** 

```
输入：nums = [5,7,7,8,8,10], target = 8
输出：[3,4]
```

 **示例 2：** 

```
输入：nums = [5,7,7,8,8,10], target = 6
输出：[-1,-1]
```

 **示例 3：** 

```
输入：nums = [], target = 0
输出：[-1,-1]
```

 **提示：** 

*   `0 <= nums.length <= 10^5`
*   `-10^9 <= nums[i] <= 10^9`
*   `nums` 是一个非递减数组
*   `-10^9 <= target <= 10^9`

---

二分查找：

方法一，通过找右边界，再向左侧延伸寻找左边界：

这里需要注意的是**找到右边界并退出循环后是右边界的下标是 `right - 1`，而不是 `right`**。

```java
class Solution {
    public int[] searchRange(int[] nums, int target) {
        int left = 0, right = nums.length;
        while(left < right){
            int mid = (left + right) >>> 1;
            if(nums[mid] <= target){
                left = mid + 1;
            }
            else if(nums[mid] > target){
                right = mid;
            }
        }
        if(right - 1 < 0 || nums[right - 1] != target) return new int[]{-1, -1};
        left = right - 1;
        while(left >= 0 && nums[left] == target) left--;
        return new int[]{left + 1, right - 1};
    }
}
```

方法二，通过找左边界，再向右侧延伸寻找右边界：

```java
class Solution {
    public int[] searchRange(int[] nums, int target) {
        int left = 0, right = nums.length;
        while(left < right){
            int mid = (left + right) >>> 1;
            if(nums[mid] < target){
                left = mid + 1;
            }
            else{
                right = mid;
            }
        }
        if(left >= nums.length || nums[left] != target) return new int[]{-1, -1};
        right = left;
        while(right < nums.length && nums[right] == target) right++;
        return new int[]{left, right - 1};
    }
}
```


方法三，找到target的下标后，向左右两侧延伸分别寻找左右边界：

```java
class Solution {
    public int[] searchRange(int[] nums, int target) {
        int left = 0, right = nums.length;
        while(left < right){
            int mid = (left + right) >>> 1;
            if(nums[mid] < target){
                left = mid + 1;
            }
            else if(nums[mid] > target){
                right = mid;
            }
            else{
                left = mid;
                break;
            }
        }
        if(left == right) return new int[]{-1, -1};
        right = left;
        while(left >= 0 && nums[left] == target) left--;
        while(right < nums.length && nums[right] == target) right++;
        return new int[]{left + 1, right - 1};
    }
}
```