#### 704. 二分查找

难度：简单

---

给定一个 `n` 个元素有序的（升序）整型数组 `nums` 和一个目标值 `target`  ，写一个函数搜索 `nums` 中的 `target`，如果目标值存在返回下标，否则返回 `-1`。


 **示例 1:** 

```
输入: nums = [-1,0,3,5,9,12], target = 9
输出: 4
解释: 9 出现在 nums 中并且下标为 4
```

 **示例 2:** 

```
输入: nums = [-1,0,3,5,9,12], target = 2
输出: -1
解释: 2 不存在 nums 中因此返回 -1
```

 **提示：** 

1.  你可以假设 `nums` 中的所有元素是不重复的。
2.  `n` 将在 `[1, 10000]`之间。
3.  `nums` 的每个元素都将在 `[-9999, 9999]`之间。

---

**✅** 二分查找有以下三种写法：

1. **前闭后闭，且循环条件为 `i <= j`**，即退出条件为 `i == j + 1`。循环退出前的范围为 `[i, i] / [i, j]`，可以考虑所有情况。

```java
class Solution {
    public int search(int[] nums, int target) {
        int i = 0, j = nums.length - 1;
        while(i <= j){
            int mid = (i + j) >>> 1;
            if(nums[mid] < target) i = mid + 1;
            else if(nums[mid] > target) j = mid - 1;
            else return mid;
        }
        return -1;
    }
}
```

2. **前闭后开，且循环条件为 `i < j`**，即退出条件为 `i == j`。循环退出前的范围为 `[i, i + 1) / [i， j)`，可以考虑所有情况。

```java
class Solution {
    public int search(int[] nums, int target) {
        int i = 0, j = nums.length;
        while(i < j){
            int mid = (i + j) >>> 1;
            if(nums[mid] < target) i = mid + 1;
            else if(nums[mid] > target) j = mid;
            else return mid;
        }
        return -1;
    }
}
```

3. 前闭后闭，且循环条件为 `i < j`，即退出条件为 `i == j`，循环退出前的范围为 `[i, i + 1] / [i， j]`，当退出循环结束时，还剩下 `nums[j]` 没有判断，**并不能考虑所有情况**。此时需要额外判断退出时 `nums[j]`（即 `num[i]`） 是否等于 `target` 。

```java
class Solution {
    public int search(int[] nums, int target) {
        int i = 0, j = nums.length - 1;
        while(i < j){
            int mid = (i + j) >>> 1;
            if(nums[mid] < target) i = mid + 1;
            else if(nums[mid] > target) j = mid;
            else return mid;
        }
        return nums[i] == target ? i : -1;
    }
}
```

**❌** 切记，有一种**不可行**的方案，也就是前闭后开，且循环条件为 `i <= j`！！

---

#### 补充

**寻找左侧边界**

在一个含重复数字的升序数组中，求 `target` 的最左侧索引值。如果 `target` 并不在数组中，则返回 `-1`

```java
/**
*
* @param arrays
* @param left = 0
* @param right = arrays.length
* @param target
* @return
*/
public static int lower_bound(int[] arrays, int left, int right, int target){
    while(left < right){
        int mid = left + (right - left) / 2;
        if(target > arrays[mid]){
            left = mid + 1;
        } else right = mid;
    }
    if (left >= arrays.length || arrays[left] != target) {
        return -1;
    }
    return left;
}
```

**寻找右侧边界**

在一个含重复数字的升序数组中，求 `target` 的最右侧索引值。如果 `target` 并不在数组中，则返回 `-1`

```java
/**
*
* @param arrays
* @param left = 0
* @param right = arrays.length
* @param target
* @return
*/
public static int upper_bound(int[] arrays, int left, int right, int target){
    while(left < right){
        int mid = left + (right - left) / 2;
        if(target < arrays[mid]){
            right = mid;
        } else left = mid + 1;
    }
    if (left - 1 < 0 || arrays[left - 1] != target) {
        return -1;
    }
    return left - 1;
}
```
