#### 878. 第 N 个神奇数字

难度：困难

---

一个正整数如果能被 `a` 或 `b` 整除，那么它是神奇的。

给定三个整数 `n` , `a` , `b` ，返回第 `n` 个神奇的数字。因为答案可能很大，所以返回答案  **对**  `10^9 + 7`  **取模**  后的值。

 **示例 1：** 

```
输入：n = 1, a = 2, b = 3
输出：2
```

 **示例 2：** 

```
输入：n = 4, a = 2, b = 3
输出：6
```

 **提示：** 

*   `1 <= n <= 10^9`
*   `2 <= a, b <= 4 * 10^4`

---

考虑到 `n` 的范围是 `1 <= n <= 10^9`，因此需要考虑一个时间复杂度小于 `O(n)` 的算法。

因此考虑二分查找，而查找的左右边界分别为 `min(a, b)` 和 `n * min(a, b)`。但是特别需要注意边界问题，左闭右开还是左闭右闭，什么条件下退出循环等等。

同时利用容斥原理，假设 `sum` 为小于等于 `x` 的神奇数字的个数。

`sum = ⌊ x / a ⌋ + ⌊ x / b ⌋ − ⌊ x / c ⌋`

例如，当 `n = 3, a = 4, b = 6` 时，即序列为 `3, 4, 5, 6, 7, 8, 9, 10, 11, 12`。当 `x = 8 或 9 或 10 或 11` 时，`sum = 2`，而在这个区间内只有 `8` 是第二个神奇数字，因此是答案是符合条件 `sum == n` 下的[最左侧边界](https://github.com/CompetitiveLin/Leetcode/blob/master/Dichotomy/704.%20%E4%BA%8C%E5%88%86%E6%9F%A5%E6%89%BE.md#%E8%A1%A5%E5%85%85)。

以下提供两个版本的代码，在边界划分以及求最大公约数的方式均有所不同。

版本1：

```java
class Solution {
    private static final long MOD = (long) 1e9 + 7;
    public int nthMagicalNumber(int n, int a, int b) {
        int c = a * b / gcd(a, b);
        long left = (long)Math.min(a, b), right = (long)left * n + 1;
        while(left < right){
            long mid = (left + right) >>> 1;
            if(mid / a + mid / b - mid / c < n) left = mid + 1;
            else if(mid / a + mid / b - mid / c >= n) right = mid;
        }
        return (int)(left % MOD);
    }

    private int gcd(int a, int b){
        return b == 0 ? a : gcd(b, a % b);
    }
}
```

版本2：

```java
class Solution {
    private static final long MOD = (long) 1e9 + 7;
    public int nthMagicalNumber(int n, int a, int b) {
        int c = a * b / gcd(a, b);
        long left = (long)Math.min(a, b), right = (long)left * n;
        while(left <= right){
            long mid = (left + right) >>> 1;
            if(mid / a + mid / b - mid / c < n) left = mid + 1;
            else if(mid / a + mid / b - mid / c >= n) right = mid -1;
        }
        return (int)((right + 1) % MOD);
    }

    private int gcd(int a, int b){
        int c;
        while(b != 0){
            c = b;
            b = a % b;
            a = c;
        }
        return a;
    }
}
```