#### 139. 单词拆分

难度：中等

---

给你一个字符串 `s` 和一个字符串列表 `wordDict` 作为字典。请你判断是否可以利用字典中出现的单词拼接出 `s` 。

 **注意：** 不要求字典中出现的单词全部都使用，并且字典中的单词可以重复使用。

 **示例 1：** 

```
输入: s = "leetcode", wordDict = ["leet", "code"]
输出: true
解释: 返回 true 因为 "leetcode" 可以由 "leet" 和 "code" 拼接成。
```

 **示例 2：** 

```
输入: s = "applepenapple", wordDict = ["apple", "pen"]
输出: true
解释: 返回 true 因为 "applepenapple" 可以由 "apple" "pen" "apple" 拼接成。
     注意，你可以重复使用字典中的单词。
```

 **示例 3：** 

```
输入: s = "catsandog", wordDict = ["cats", "dog", "sand", "and", "cat"]
输出: false
```

 **提示：** 

*   `1 <= s.length <= 300`
*   `1 <= wordDict.length <= 1000`
*   `1 <= wordDict[i].length <= 20`
*   `s` 和 `wordDict[i]` 仅有小写英文字母组成
*   `wordDict` 中的所有字符串  **互不相同**

---

动态规划：`dp[i]` 的含义是前 `i` 个字符可以用字典中的单词拼接而成。那么最后返回 `dp[s.length()]` 即可。循环过程与冒泡排序类似。

转移方程见代码部分，意思是如果前 `j` 个字符可以由字典中的单词拼接而成，且下标从 `j` 到 `i - 1` 的子串也在字典中，也就意味着前 `i` 个字符可以由字典中的单词拼接而成。

```java
class Solution {
    public boolean wordBreak(String s, List<String> wordDict) {
        boolean[] dp = new boolean[s.length() + 1];
        dp[0] = true;
        for(int i = 1; i <= s.length(); i++){
            for(int j = 0; j < i; j++){
                if(dp[j] && wordDict.contains(s.substring(j, i))){
                    dp[i] = true;
                    break;
                }
            }
        }
        return dp[s.length()];
    }
}
```

