#### 1626. 无矛盾的最佳球队

难度：中等

---

假设你是球队的经理。对于即将到来的锦标赛，你想组合一支总体得分最高的球队。球队的得分是球队中所有球员的分数  **总和**  。

然而，球队中的矛盾会限制球员的发挥，所以必须选出一支  **没有矛盾**  的球队。如果一名年龄较小球员的分数  **严格大于**  一名年龄较大的球员，则存在矛盾。同龄球员之间不会发生矛盾。

给你两个列表 `scores` 和 `ages`，其中每组 `scores[i]` 和 `ages[i]` 表示第 `i` 名球员的分数和年龄。请你返回  **所有可能的无矛盾球队中得分最高那支的分数**  。

 **示例 1：** 

```
输入：scores = [1,3,5,10,15], ages = [1,2,3,4,5]
输出：34
解释：你可以选中所有球员。
```

 **示例 2：** 

```
输入：scores = [4,5,6,5], ages = [2,1,2,1]
输出：16
解释：最佳的选择是后 3 名球员。注意，你可以选中多个同龄球员。
```

 **示例 3：** 

```
输入：scores = [1,2,3,5], ages = [8,9,10,1]
输出：6
解释：最佳的选择是前 3 名球员。
```

 **提示：** 

*   `1 <= scores.length, ages.length <= 1000`
*   `scores.length == ages.length`
*   `1 <= scores[i] <= 10^6`
*   `1 <= ages[i] <= 1000`

---

排序 + 动态规划：

`people[i][0], people[i][1]` 分别表示下标为 `i` 的人的分数和年龄。

将 `people` 数组按照**分数降序**进行排序，分数相同时，则按照**年龄降序**进行排序。

动态规划部分，`dp[i]` 表示最后一名球员的下标为 `i` 时能获得的最大分数，求解 `dp[i]` 需要向前遍历查找年龄满足条件（年龄大于等于当前下标为 `i` ）的最大值情况，遍历数组取最大即可。即[此处](https://github.com/CompetitiveLin/Leetcode/blob/master/Dynamic%20Programming/README.md)的**第一种**情况。

这里需要注意的是：

1. 不能将年龄升序排序。因为是从后向前遍历查找，当分数相同时，如果按年龄升序排序，不满足条件的情况反而出现在数组前面（后遍历到）。
2. “如果一名年龄较小球员的分数 **严格大于** 一名年龄较大的球员，则存在矛盾。”其反义是：年龄较大球员的分数大于等于另一位球员 **或者** 两球员年龄相同，不存在矛盾。

```Java
class Solution {
    public int bestTeamScore(int[] scores, int[] ages) {
        int n = scores.length;
        int[][] people = new int[n][2];
        for(int i = 0; i < n; i++){
            people[i][0] = scores[i];
            people[i][1] = ages[i];
        }
        Arrays.sort(people, (a, b) -> (a[0] != b[0] ? b[0] - a[0] : b[1] - a[1]));
        int[] dp = new int[n];
        dp[0] = people[0][0];
        int ans = dp[0];
        for(int i = 1; i < n; i++){
            for(int j = i - 1; j >= 0; j--){
                if(people[j][1] >= people[i][1]){
                    dp[i] = Math.max(dp[i], dp[j]);
                }
            }
            dp[i] += people[i][0];
            ans = Math.max(ans, dp[i]);
        }
        return ans;
    }
}
```