#### 1691. 堆叠长方体的最大高度

难度：困难

---

给你 `n` 个长方体 `cuboids` ，其中第 `i` 个长方体的长宽高表示为 `cuboids[i] = [widthi, lengthi, heighti]`（ **下标从 0 开始** ）。请你从 `cuboids` 选出一个  **子集**  ，并将它们堆叠起来。

如果 `widthi <= widthj` 且 `lengthi <= lengthj` 且 `heighti <= heightj` ，你就可以将长方体 `i` 堆叠在长方体 `j` 上。你可以通过旋转把长方体的长宽高重新排列，以将它放在另一个长方体上。

返回  **堆叠长方体**  `cuboids` 可以得到的  **最大高度**  。

 **示例 1：** 

 **![](https://assets.leetcode-cn.com/aliyun-lc-upload/uploads/2020/12/12/image.jpg)** 

```
输入：cuboids = [[50,45,20],[95,37,53],[45,23,12]]
输出：190
解释：
第 1 个长方体放在底部，53x37 的一面朝下，高度为 95 。
第 0 个长方体放在中间，45x20 的一面朝下，高度为 50 。
第 2 个长方体放在上面，23x12 的一面朝下，高度为 45 。
总高度是 95 + 50 + 45 = 190 。
```

 **示例 2：** 

```
输入：cuboids = [[38,25,45],[76,35,3]]
输出：76
解释：
无法将任何长方体放在另一个上面。
选择第 1 个长方体然后旋转它，使 35x3 的一面朝下，其高度为 76 。
```

 **示例 3：** 

```
输入：cuboids = [[7,11,17],[7,17,11],[11,7,17],[11,17,7],[17,7,11],[17,11,7]]
输出：102
解释：
重新排列长方体后，可以看到所有长方体的尺寸都相同。
你可以把 11x7 的一面朝下，这样它们的高度就是 17 。
堆叠长方体的最大高度为 6 * 17 = 102 。
```

 **提示：** 

*   `n == cuboids.length`
*   `1 <= n <= 100`
*   `1 <= widthi, lengthi, heighti <= 100`

---
自定义排序 + 动态规划：

在求 `dp` 数组之前，需要对数据进行预处理：

1. 每一对长宽高都以升序排序。即，使高度最大化。

2. `cuboids` 数组的长宽高按递增或递减排序，模拟堆叠的过程。递增则是向下堆，递减则是向上堆。

`dp[i]` 表示以 `cuboids[i]` 结尾的堆叠长方体的最大高度。此时，`cuboids[i]` 一定是最顶上的那个长方体。遍历所有 `dp[i]` 便可求得最大高度。以下是状态转移方程：

$$ dp[i] = cuboids[i] + \mathop{max}\limits_{0 \le j < i}dp[j], \text{if} (w[i] \ge w[j]) \\& (l[i] \ge l[j]) \\& (h[i] \ge h[j]) $$

```java
class Solution {
    public int maxHeight(int[][] cuboids) {
        int n = cuboids.length, ans = 0;
        for(int i = 0; i < n; i++) Arrays.sort(cuboids[i]);
        Arrays.sort(cuboids, (a, b) -> a[0] != b[0] ? a[0] - b[0] : a[1] != b[1] ? a[1] - b[1] : a[2] - b[2]);
        int[] dp = new int[n];
        for(int i = 0; i < n; i++){
            for(int j = 0; j < i; j++){
                if(cuboids[i][1] >= cuboids[j][1] && cuboids[i][2] >= cuboids[j][2]){
                    dp[i] = Math.max(dp[i], dp[j]);
                }
            }
            dp[i] += cuboids[i][2];
            ans = Math.max(ans, dp[i]);
        }
        return ans;
    }
}
```
