#### 213. 打家劫舍 II

难度：中等

---

你是一个专业的小偷，计划偷窃沿街的房屋，每间房内都藏有一定的现金。这个地方所有的房屋都  **围成一圈**  ，这意味着第一个房屋和最后一个房屋是紧挨着的。同时，相邻的房屋装有相互连通的防盗系统， **如果两间相邻的房屋在同一晚上被小偷闯入，系统会自动报警**  。

给定一个代表每个房屋存放金额的非负整数数组，计算你  **在不触动警报装置的情况下**  ，今晚能够偷窃到的最高金额。

 **示例 1：** 

```
输入：nums = [2,3,2]
输出：3
解释：你不能先偷窃 1 号房屋（金额 = 2），然后偷窃 3 号房屋（金额 = 2）, 因为他们是相邻的。
```

 **示例 2：** 

```
输入：nums = [1,2,3,1]
输出：4
解释：你可以先偷窃 1 号房屋（金额 = 1），然后偷窃 3 号房屋（金额 = 3）。
     偷窃到的最高金额 = 1 + 3 = 4 。
```

 **示例 3：** 

```
输入：nums = [1,2,3]
输出：3
```

 **提示：** 

*   `1 <= nums.length <= 100`
*   `0 <= nums[i] <= 1000`

---

动态规划：

与打家劫舍相比，考虑以下两种情况：

1. 偷 `nums[0]`，那么 `nums[1]` 和 `nums[n - 1]` 不能偷，问题变成了 `nums[2]` 到 `nums[n - 2]` 的打家劫舍
2. 不偷 `nums[0]`，那么问题变成了 `nums[1]` 到 `nums[n - 1]` 的打家劫舍

```Java
class Solution {
    public int rob(int[] nums) {
        int n = nums.length;
        return Math.max(nums[0] + subrob(nums, 2, n - 1), subrob(nums, 1, n));
    }

    private int subrob(int[] nums, int left, int right){
        int f0 = 0, f1 = 0;
        for(int i = left; i < right; i++){
            int newF = Math.max(f1, f0 + nums[i]);
            f0 = f1;
            f1 = newF;
        }
        return f1;
    }
}
```