#### 300. 最长递增子序列

难度：中等

---

给你一个整数数组 `nums` ，找到其中最长严格递增子序列的长度。

 **子序列**  是由数组派生而来的序列，删除（或不删除）数组中的元素而不改变其余元素的顺序。例如，`[3,6,2,7]` 是数组 `[0,3,1,6,2,2,7]` 的子序列。

 

 **示例 1：** 

```
输入：nums = [10,9,2,5,3,7,101,18]
输出：4
解释：最长递增子序列是 [2,3,7,101]，因此长度为 4 。
```

 **示例 2：** 

```
输入：nums = [0,1,0,3,2,3]
输出：4
```

 **示例 3：** 

```
输入：nums = [7,7,7,7,7,7,7]
输出：1
```

 **提示：** 

*   `1 <= nums.length <= 2500`
*   `-10^4 <= nums[i] <= 10^4`

**进阶：**

*   你能将算法的时间复杂度降低到 `O(n log(n))` 吗?

---

动态规划：

与 [1626. 无矛盾的最佳球队 ](https://leetcode.cn/problems/best-team-with-no-conflicts/)类似。

```Java
class Solution {
    public int lengthOfLIS(int[] nums) {
        int n = nums.length;
        int[] dp = new int[n];
        dp[0] = 1;
        int ans = dp[0];
        for(int i = 1; i < n; i++){
            for(int j = i - 1; j >= 0; j--){
                if(nums[j] < nums[i]){
                    dp[i] = Math.max(dp[i], dp[j]);
                }
            }
            dp[i] += 1;
            ans = Math.max(ans, dp[i]);
        }
        return ans;
    }
}
```