#### 62. 不同路径

难度：中等

---

一个机器人位于一个 `m x n` 网格的左上角 （起始点在下图中标记为 “Start” ）。

机器人每次只能向下或者向右移动一步。机器人试图达到网格的右下角（在下图中标记为 “Finish” ）。

问总共有多少条不同的路径？

 **示例 1：** 

![](https://assets.leetcode.com/uploads/2018/10/22/robot_maze.png)
```
输入：m = 3, n = 7
输出：28
```

 **示例 2：** 

```
输入：m = 3, n = 2
输出：3
解释：
从左上角开始，总共有 3 条路径可以到达右下角。
1. 向右 -> 向下 -> 向下
2. 向下 -> 向下 -> 向右
3. 向下 -> 向右 -> 向下
```

 **示例 3：** 

```
输入：m = 7, n = 3
输出：28
```

 **示例 4：** 

```
输入：m = 3, n = 3
输出：6
```

 **提示：** 

*   `1 <= m, n <= 100`
*   题目数据保证答案小于等于 `2 * 10^9`

---

方法一，简单动态规划：

当前格的路径数为上方格的路径数加上左侧格的路径数，空间复杂度$O(m*n)$，时间复杂度$O(m*n)$

```java
class Solution {
    public int uniquePaths(int m, int n) {
        int[][] dp = new int[m][n];
        for(int i = 0; i < m; i++){
            dp[i][0] = 1;
        }
        for(int j = 0; j < n; j++){
            dp[0][j] = 1;
        }
        for(int i = 1; i < m; i++){
            for(int j = 1; j < n; j++){
                dp[i][j] = dp[i - 1][j] + dp[i][j - 1];
            }
        }
        return dp[m - 1][n - 1];
    }
    
}
```



方法二，法一的优化方法，时间复杂度$O(m * n)$，空间复杂度$O(n)$。

```Java
class Solution {
    public int uniquePaths(int m, int n) {
        int[] dp = new int[n];
        for(int i = 0; i < n; i++){
            dp[i] = 1;
        }
        for(int i = 1; i < m; i++){
            for(int j = 1; j < n; j++){
                dp[j] += dp[j - 1];
            }
        }
        return dp[n - 1];
    }
    
}
```



方法三，排列组合：

从左上角移动到右下角一共需要移动 `m + n - 2` 次，其中 `m - 1` 次向下移动，`n - 1` 次向右移动。因此路径的总数是从 `m + n - 2` 次的移动中选择 `m - 1` 次的向下移动（或者 `n - 1` 的向右移动）。即 $C_{m+n-2}^{m - 1}$ （或 $C_{m+n-2}^{n - 1}$） $= \frac{(m+n-2)!}{(m-1)!(n-1)!}$。时间复杂度$O(m)$，空间复杂度$O(1)$。

```java
class Solution {
    public int uniquePaths(int m, int n) {
        long ans = 1;
        for (int x = n, y = 1; y < m; ++x, ++y) {
            ans = ans * x / y;
        }
        return (int) ans;
    }
}
```

