#### 795. 区间子数组个数

难度：中等

---

给你一个整数数组 `nums` 和两个整数：`left` 及 `right` 。找出 `nums` 中连续、非空且其中最大元素在范围 `[left, right]` 内的子数组，并返回满足条件的子数组的个数。

生成的测试用例保证结果符合  **32-bit**  整数范围。

 **示例 1：** 

```
输入：nums = [2,1,4,3], left = 2, right = 3
输出：3
解释：满足条件的三个子数组：[2], [2, 1], [3]
```

 **示例 2：** 

```
输入：nums = [2,9,2,5,6], left = 2, right = 8
输出：7
```

 **提示：** 

*   `1 <= nums.length <= 10^5`
*   `0 <= nums[i] <= 10^9`
*   `0 <= left <= right <= 10^9`

---

动态规划：一维数组 `dp[i]` 表示以 `nums[i]` 结尾的满足条件的子数组个数。因此最后结果就是 `dp` 数组的和。对于 `nums[i]` 的取值，有以下三种情况：

- `nums[i] > right`，不存在以 `nums[i]` 结尾且满足条件的子数组，即 `dp[i] = 0`

- `nums[i] < left`，以 `nums[i]` 结尾的满足条件的子数组个数与以 `nums[i - 1]` 结尾的个数相等，即 `dp[i] = dp[i - 1]`

- `nums[i] >= left && nums[i] <= right`，子数组个数由以下三种情况相加：

  - `nums[i]` 自身，个数为 `1`

  - `dp[i - 1]` 中的所有情况加上 `nums[i]` 形成新的子数组，个数为 `dp[i - 1]`

  - 如果 `nums[i - 1]` 小于 `left`，以最接近且连续不满足条件的元素组成的数组加上 `nums[i]` 的情况。例如 `2, 1, 1, 1, 3 (left = 2, right = 4)` 的情况下，需要额外加上 `[1, 3], [1, 1, 3], [1, 1, 1, 3]` 这三种情况。借助一个辅助下标 `j` 记录最后一个满足条件的下标即可，在上述例子中，`i = 4, j = 0`。如果不小于，则 `j = i - 1` 。因此个数为 `i - j - 1`

  所以 `dp[i] = 1 + dp[i - 1] + i - j - 1`

```java
class Solution {
    public int numSubarrayBoundedMax(int[] nums, int left, int right) {
        int n = nums.length, index = (nums[0] >= left) ? 0 : -1;
        int[] dp = new int[n];
        dp[0] = (nums[0] >= left && nums[0] <= right) ? 1 : 0;
        for(int i = 1; i < n; i++){
            if(nums[i] > right){
                dp[i] = 0;
            }
            else if(nums[i] >= left){
                dp[i] = dp[i - 1] + i - index;
            }else{
                dp[i] = dp[i - 1];
            }
            if(nums[i] >= left) index = i;
        }
        
        return Arrays.stream(dp).sum();
    }
}
```