#### 1775. 通过最少操作次数使数组的和相等

难度：中等

---

给你两个长度可能不等的整数数组 `nums1` 和 `nums2` 。两个数组中的所有值都在 `1` 到 `6` 之间（包含 `1` 和 `6`）。

每次操作中，你可以选择  **任意**  数组中的任意一个整数，将它变成 `1` 到 `6` 之间  **任意**  的值（包含 `1` 和 `6`）。

请你返回使 `nums1` 中所有数的和与 `nums2` 中所有数的和相等的最少操作次数。如果无法使两个数组的和相等，请返回 `-1` 。

 **示例 1：** 

```
输入：nums1 = [1,2,3,4,5,6], nums2 = [1,1,2,2,2,2]
输出：3
解释：你可以通过 3 次操作使 nums1 中所有数的和与 nums2 中所有数的和相等。以下数组下标都从 0 开始。
- 将 nums2[0] 变为 6 。 nums1 = [1,2,3,4,5,6], nums2 = [6,1,2,2,2,2] 。
- 将 nums1[5] 变为 1 。 nums1 = [1,2,3,4,5,1], nums2 = [6,1,2,2,2,2] 。
- 将 nums1[2] 变为 2 。 nums1 = [1,2,2,4,5,1], nums2 = [6,1,2,2,2,2] 。
```

 **示例 2：** 

```
输入：nums1 = [1,1,1,1,1,1,1], nums2 = [6]
输出：-1
解释：没有办法减少 nums1 的和或者增加 nums2 的和使二者相等。
```

 **示例 3：** 

```
输入：nums1 = [6,6], nums2 = [1]
输出：3
解释：你可以通过 3 次操作使 nums1 中所有数的和与 nums2 中所有数的和相等。以下数组下标都从 0 开始。
- 将 nums1[0] 变为 2 。 nums1 = [2,6], nums2 = [1] 。
- 将 nums1[1] 变为 2 。 nums1 = [2,2], nums2 = [1] 。
- 将 nums2[0] 变为 4 。 nums1 = [2,2], nums2 = [4] 。
```

 **提示：** 

*   `1 <= nums1.length, nums2.length <= 10^5`
*   `1 <= nums1[i], nums2[i] <= 6`

---

贪心 + 哈希表：

已知，要使操作次数最少，一定是数组中的最大值（`6`）变为最小值（`1`）或者最小值（`1`）变为最大值（`6`）。

开辟一个变量记录两数组总和的差值（大于零）以及一个额外的数组记录给定两个数组中每个数字可以变化的最大值，直到差值小于等于零为止。

补充一点向上取整与向下取整的写法：

- 向下取整：`x / y` 

- 向上取整：`(x + y - 1) / y` ，等同于 `(int) Math.ceil(x * 1.0 / y)`

```java
class Solution {
    public int minOperations(int[] nums1, int[] nums2) {
        int n = nums1.length, m = nums2.length, ans = 0, diff = 0;
        if(n * 6 < m || n > 6 * m) return -1;
        for(int i: nums1)   diff += i;
        for(int i: nums2)   diff -= i;
        if(diff == 0) return 0;
        else if(diff < 0){
            diff *= -1;
            int[] temp = nums1;
            nums1 = nums2;
            nums2 = temp;
        }
        int[] cnt = new int[6];
        for(int i: nums1) cnt[i - 1]++;
        for(int i: nums2) cnt[6 - i]++;
        for(int i = 5; ; i--){
            if(diff <= i * cnt[i]) return ans + (diff + i - 1) / i; // 向下取整，等同于(int)Math.ceil(diff * 1.0 / i)
            diff -= i * cnt[i];
            ans += cnt[i];
        }
    }
}
```

