#### 2611. 老鼠和奶酪

难度：中等

---

有两只老鼠和 `n` 块不同类型的奶酪，每块奶酪都只能被其中一只老鼠吃掉。

下标为 `i` 处的奶酪被吃掉的得分为：

*   如果第一只老鼠吃掉，则得分为 `reward1[i]` 。
*   如果第二只老鼠吃掉，则得分为 `reward2[i]` 。

给你一个正整数数组 `reward1` ，一个正整数数组 `reward2` ，和一个非负整数 `k` 。

请你返回第一只老鼠恰好吃掉 `k` 块奶酪的情况下， **最大**  得分为多少。

 **示例 1：** 

```
输入：reward1 = [1,1,3,4], reward2 = [4,4,1,1], k = 2
输出：15
解释：这个例子中，第一只老鼠吃掉第 2 和 3 块奶酪（下标从 0 开始），第二只老鼠吃掉第 0 和 1 块奶酪。
总得分为 4 + 4 + 3 + 4 = 15 。
15 是最高得分。
```

 **示例 2：** 

```
输入：reward1 = [1,1], reward2 = [1,1], k = 2
输出：2
解释：这个例子中，第一只老鼠吃掉第 0 和 1 块奶酪（下标从 0 开始），第二只老鼠不吃任何奶酪。
总得分为 1 + 1 = 2 。
2 是最高得分。
```

 **提示：** 

*   `1 <= n == reward1.length == reward2.length <= 10^5`
*   `1 <= reward1[i], reward2[i] <= 1000`
*   `0 <= k <= n`

---

方法一：排序 + 贪心：

第一只老鼠吃掉 k 个奶酪，剩下的给第二只老鼠吃，意味着这 k 个奶酪一定是差值最大的奶酪。那么以第二只老鼠的得分为基准，那么再加上 k 个得分差即可。

```java
class Solution {
    public int miceAndCheese(int[] reward1, int[] reward2, int k) {
        int n = reward1.length, ans = 0;
        int[] diff = new int[n];
        for(int i = 0; i < n; i++){
            diff[i] = reward1[i] - reward2[i];
            ans += reward2[i];
        }
        Arrays.sort(diff);
        for(int i = 0; i < k; i++){
            ans += diff[n - i - 1];
        }
        return ans;
    }
}
```



方法二：优先队列 + 贪心：

本题类似于**选择 k 个最大值**，那么维护一个长度为 k 的**最小堆**（优先队列），那么堆中存放的元素即是整个数组中的 k 个最大值。

```Java
class Solution {
    public int miceAndCheese(int[] reward1, int[] reward2, int k) {
        int n = reward1.length, ans = 0;
        PriorityQueue<Integer> pq = new PriorityQueue<>();
        for(int i = 0; i < n; i++){
            ans += reward2[i];
            pq.offer(reward1[i] - reward2[i]);
            if(pq.size() > k){
                pq.poll();
            }
        }
        while(!pq.isEmpty()){
            ans += pq.poll();
        }
        return ans;
    }
}
```