#### 435. 无重叠区间

难度：中等

---

给定一个区间的集合 `intervals` ，其中 `intervals[i] = [starti, endi]` 。返回 _需要移除区间的最小数量，使剩余区间互不重叠_ 。

 **示例 1:** 

```
输入: intervals = [[1,2],[2,3],[3,4],[1,3]]
输出: 1
解释: 移除 [1,3] 后，剩下的区间没有重叠。
```

 **示例 2:** 

```
输入: intervals = [ [1,2], [1,2], [1,2] ]
输出: 2
解释: 你需要移除两个 [1,2] 来使剩下的区间没有重叠。
```

 **示例 3:** 

```
输入: intervals = [ [1,2], [2,3] ]
输出: 0
解释: 你不需要移除任何区间，因为它们已经是无重叠的了。
```

 **提示:** 

*   `1 <= intervals.length <= 10^5`
*   `intervals[i].length == 2`
*   `-5 * 10^4 <= starti < endi <= 5 * 10^4`

---

经典贪心算法：

区间右端点排序！！！然后记录最大不重叠区间，最后用总数减去该不重叠区间数即可。

```Java
class Solution {
    public int eraseOverlapIntervals(int[][] intervals) {
        Arrays.sort(intervals, (a, b) -> (a[1] - b[1]));
        int n = intervals.length, right = intervals[0][1], ans = 1;
        for(int i = 1; i < n; i++){
            if(intervals[i][0] >= right){
                ans++;
                right = intervals[i][1];
            }
        }
        return n - ans;
    }
}
```