#### 452. 用最少数量的箭引爆气球

难度：中等

---

有一些球形气球贴在一堵用 XY 平面表示的墙面上。墙面上的气球记录在整数数组 `points` ，其中`points[i] = [xstart, xend]` 表示水平直径在 `xstart` 和 `xend`之间的气球。你不知道气球的确切 y 坐标。

一支弓箭可以沿着 x 轴从不同点  **完全垂直**  地射出。在坐标 `x` 处射出一支箭，若有一个气球的直径的开始和结束坐标为 `x``start`，`x``end`， 且满足  `xstart ≤ x ≤ x``end`，则该气球会被  **引爆**  。可以射出的弓箭的数量  **没有限制**  。 弓箭一旦被射出之后，可以无限地前进。

给你一个数组 `points` ，_返回引爆所有气球所必须射出的  **最小**  弓箭数_ 。

 

 **示例 1：** 

```
输入：points = [[10,16],[2,8],[1,6],[7,12]]
输出：2
解释：气球可以用2支箭来爆破:
-在x = 6处射出箭，击破气球[2,8]和[1,6]。
-在x = 11处发射箭，击破气球[10,16]和[7,12]。
```

 **示例 2：** 

```
输入：points = [[1,2],[3,4],[5,6],[7,8]]
输出：4
解释：每个气球需要射出一支箭，总共需要4支箭。
```

 **示例 3：** 

```
输入：points = [[1,2],[2,3],[3,4],[4,5]]
输出：2
解释：气球可以用2支箭来爆破:
- 在x = 2处发射箭，击破气球[1,2]和[2,3]。
- 在x = 4处射出箭，击破气球[3,4]和[4,5]。
```

 **提示:** 

*   `1 <= points.length <= 10^5`
*   `points[i].length == 2`
*   `-2^31 <= xstart < xend <= 2^31 - 1`

---

排序 + 贪心：

将右端点以升序排序，每根弓箭都是取右端点值最小的点（贪心），同时不考虑左端点比该点小的气球（即弓箭能引爆该气球），直到取完所有点为止。

```Java
class Solution {
    public int findMinArrowShots(int[][] points) {
        Arrays.sort(points, (a, b) -> {
            return Integer.compare(a[1], b[1]);
        });
        int ans = 1, last = points[0][1];
        for(int[] temp: points){
            if(temp[0] > last){
                ans++;
                last = temp[1];
            }
        }
        return ans;
    }
}
```