#### 763. 划分字母区间

难度：中等

---

给你一个字符串 `s` 。我们要把这个字符串划分为尽可能多的片段，同一字母最多出现在一个片段中。

注意，划分结果需要满足：将所有划分结果按顺序连接，得到的字符串仍然是 `s` 。

返回一个表示每个字符串片段的长度的列表。

 **示例 1：** 
```
输入：s = "ababcbacadefegdehijhklij"
输出：[9,7,8]
解释：
划分结果为 "ababcbaca"、"defegde"、"hijhklij" 。
每个字母最多出现在一个片段中。
像 "ababcbacadefegde", "hijhklij" 这样的划分是错误的，因为划分的片段数较少。
```

 **示例 2：** 

```
输入：s = "eccbbbbdec"
输出：[10]
```

 **提示：** 

*   `1 <= s.length <= 500`
*   `s` 仅由小写英文字母组成

---

贪心：

由于同一个字母只能出现在同一个片段，显然同一个字母的第一次出现的下标位置和最后一次出现的下标位置必须出现在同一个片段。

因此先顺序遍历，记录每一个字母出现的最大下标处。

接着再顺序遍历一遍，遍历的过程中将指针**移动当前字母出现的最大下标处**。如果指针刚好是当前下标，则意味着从起始位置到当前位置是一个符合要求的答案，接着更新起始位置下标继续遍历。

```Java
class Solution {
    public List<Integer> partitionLabels(String s) {
        int n = s.length();
        int[] alphabet = new int[26];
        for(int i = 0; i < n; i++){
            alphabet[s.charAt(i) - 'a'] = i;
        }
        List<Integer> res = new ArrayList<>();
        int start = 0, end = 0;
        for(int i = 0; i < n; i++){
            end = Math.max(end, alphabet[s.charAt(i) - 'a']);	// 直接将尾指针移到了当前字母出现的最大下标处
            if(i == end){
                res.add(end - start + 1);
                start = end + 1;
            }
        }
        return res;
    }
}
```