#### 49. 字母异位词分组

难度：中等

---

给你一个字符串数组，请你将  **字母异位词**  组合在一起。可以按任意顺序返回结果列表。

 **字母异位词**  是由重新排列源单词的字母得到的一个新单词，所有源单词中的字母通常恰好只用一次。

 **示例 1:** 

```
输入: strs = ["eat", "tea", "tan", "ate", "nat", "bat"]
输出: [["bat"],["nat","tan"],["ate","eat","tea"]]
```

 **示例 2:** 

```
输入: strs = [""]
输出: [[""]]
```

 **示例 3:** 

```
输入: strs = ["a"]
输出: [["a"]]
```

 **提示：** 

*   `1 <= strs.length <= 10^4`
*   `0 <= strs[i].length <= 100`
*   `strs[i]` 仅包含小写字母

---

哈希：

对于字符串数组中的每一个字符串，按其字典序排序（实现方式是用长度为26的数组记录），如果在哈希表中存在该排序后的字符串，则存入列表中。

```Java
class Solution {
    public List<List<String>> groupAnagrams(String[] strs) {
        HashMap<String, List<String>> hashmap = new HashMap<>();
        int n = strs.length;
        for(int i = 0; i < n; i++){
            int[] alphabet = new int[26];
            for(int j = 0; j < strs[i].length(); j++){
                char c = strs[i].charAt(j);
                alphabet[c - 'a'] ++;
            }
            StringBuilder sb = new StringBuilder();
            for(int j = 0; j < 26; j++){
                while(alphabet[j] != 0){
                    sb.append(j + 'a');
                    alphabet[j]--;
                }
            }
            String key = sb.toString();
            List<String> temp = hashmap.getOrDefault(key, new ArrayList<String>());
            temp.add(strs[i]);
            hashmap.put(key, temp);
        }
        return new ArrayList<List<String>>(hashmap.values());
    }
}
```