#### 560. 和为 K 的子数组

难度：中等

---

给你一个整数数组 `nums` 和一个整数 `k` ，请你统计并返回 _该数组中和为 `k` 的连续子数组的个数_ 。

 **示例 1：** 

```
输入：nums = [1,1,1], k = 2
输出：2
```

 **示例 2：** 

```
输入：nums = [1,2,3], k = 3
输出：2
```

 **提示：** 

*   `1 <= nums.length <= 2 * 10^4`
*   `-1000 <= nums[i] <= 1000`
*   `-10^7 <= k <= 10^7`

---

前缀和 + 哈希表：

若用数组 `pre[n]` 记录 `[0,n]` 所有数的和，那么 `pre[i] = pre[i - 1] + nums[i]`，也就是数组 `pre[n]` 是一个记录前缀和的数组。若**连续子数组** `[j,...,i]` 的和为 `k`，那么可以得到 `pre[i] - pre[j - 1] = k`，即 `pre[j - 1] = pre[i] - k`。因此如果将数组替换成哈希表，即可在 `O(1)` 时间内查找到是否存在某个下标为 `j - 1`（当然，下标不重要），值为 `pre[i] - k` 的数。附上[参考链接](https://leetcode.cn/problems/subarray-sum-equals-k/solution/he-wei-kde-zi-shu-zu-by-leetcode-solution/)。

```Java
class Solution {
    public int subarraySum(int[] nums, int k) {
        int ans = 0, n = nums.length, sum = 0;
        HashMap<Integer, Integer> hashmap = new HashMap<>();
        hashmap.put(0, 1);
        for(int i = 0; i < n; i++){
            sum += nums[i];
            if(hashmap.containsKey(sum - k)){
                ans += hashmap.get(sum - k);
            }
            hashmap.put(sum, hashmap.getOrDefault(sum, 0) + 1);
        }
        return ans;
    }
}
```