#### 28. 找出字符串中第一个匹配项的下标

难度：中等

---

给你两个字符串 `haystack` 和 `needle` ，请你在 `haystack` 字符串中找出 `needle` 字符串的第一个匹配项的下标（下标从 0 开始）。如果 `needle` 不是 `haystack` 的一部分，则返回  `-1` 。

 **示例 1：** 

```
输入：haystack = "sadbutsad", needle = "sad"
输出：0
解释："sad" 在下标 0 和 6 处匹配。
第一个匹配项的下标是 0 ，所以返回 0 。
```

 **示例 2：** 

```
输入：haystack = "leetcode", needle = "leeto"
输出：-1
解释："leeto" 没有在 "leetcode" 中出现，所以返回 -1 。
```

 **提示：** 

*   `1 <= haystack.length, needle.length <= 10^4`
*   `haystack` 和 `needle` 仅由小写英文字符组成

---

KMP 模板题：

```java
class Solution {
    public int strStr(String haystack, String needle) {
        return kmp(haystack, needle);
    }

    private int kmp(String haystack, String needle){
        int[] next = getNext(needle);
        int i = 0, j = 0;
        while(i < haystack.length() && j < needle.length()){
            if(j == -1 || haystack.charAt(i) == needle.charAt(j)){
                i++;
                j++;
            } else j = next[j];
        }
        if(j == needle.length()) return i - j;
        return -1;
    }

    private int[] getNext(String needle){
        int[] next = new int[needle.length()];
        next[0] = -1;
        int j = 0, k = -1;
        while(j < needle.length() - 1){
            if(k == -1 || needle.charAt(j) == needle.charAt(k)){
                if(needle.charAt(++j) == needle.charAt(++k))  next[j] = next[k];
                else next[j] = k;
            } else k = next[k];
        }
        return next;
    }
}
```