#### 142. 环形链表 II

难度：中等

---

给定一个链表的头节点  `head` ，返回链表开始入环的第一个节点。 _如果链表无环，则返回 `null`。_

如果链表中有某个节点，可以通过连续跟踪 `next` 指针再次到达，则链表中存在环。 为了表示给定链表中的环，评测系统内部使用整数 `pos` 来表示链表尾连接到链表中的位置（ **索引从 0 开始** ）。如果 `pos` 是 `-1`，则在该链表中没有环。 **注意：`pos` 不作为参数进行传递** ，仅仅是为了标识链表的实际情况。

 **不允许修改**  链表。

 **示例 1：** 

![](https://assets.leetcode.com/uploads/2018/12/07/circularlinkedlist.png)

```
输入：head = [3,2,0,-4], pos = 1
输出：返回索引为 1 的链表节点
解释：链表中有一个环，其尾部连接到第二个节点。
```

 **示例 2：** 

![](https://assets.leetcode-cn.com/aliyun-lc-upload/uploads/2018/12/07/circularlinkedlist_test2.png)

```
输入：head = [1,2], pos = 0
输出：返回索引为 0 的链表节点
解释：链表中有一个环，其尾部连接到第一个节点。
```

 **示例 3：** 

![](https://assets.leetcode-cn.com/aliyun-lc-upload/uploads/2018/12/07/circularlinkedlist_test3.png)

```
输入：head = [1], pos = -1
输出：返回 null
解释：链表中没有环。
```

 **提示：** 

*   链表中节点的数目范围在范围 `[0, 10^4]` 内
*   `-10^5 <= Node.val <= 10^5`
*   `pos` 的值为 `-1` 或者链表中的一个有效索引

 **进阶：** 你是否可以使用 `O(1)` 空间解决此题？

---

快慢指针：

![](https://raw.githubusercontent.com/CompetitiveLin/ImageHostingService/picgo/imgs/202310232256747.png)

快指针走过的路程永远是慢指针的两倍，根据这个性质得到以下公式：
$$
a + n * (b + c) + b = 2 * (a + b)
$$
化简后为
$$
a = (n - 1) * (b + c) + c
$$
可以发现 $(b + c)$ 恰好为环的长度，那么意味着从链表头部到入环的距离（$a$）恰好等于从相遇点到入环点的距离（$c$）再加上 $n-1$ 圈个环的长度。**当快慢指针相遇后，再定义一个指针指向链表起点，一次走一步，`slow` 指针也同步继续往后走，那么这两个指针就一定会在链表的入口位置相遇。**

```Java
/**
 * Definition for singly-linked list.
 * class ListNode {
 *     int val;
 *     ListNode next;
 *     ListNode(int x) {
 *         val = x;
 *         next = null;
 *     }
 * }
 */
public class Solution {
    public ListNode detectCycle(ListNode head) {
        if(head == null || head.next == null) return null;
        ListNode slow = head, fast = head;
        while(fast != null && fast.next != null){
            slow = slow.next;
            fast = fast.next.next;
            if(slow == fast){
                ListNode ans = head;
                while(slow != ans){
                    slow = slow.next;
                    ans = ans.next;
                }
                return ans;
            }
            
        }
        return null;
    }
}
```