#### 143. 重排链表

难度：中等

---

给定一个单链表 `L` 的头节点 `head` ，单链表 `L` 表示为：

```
L0 → L1 → … → Ln - 1 → Ln
```

请将其重新排列后变为：

```
L0 → Ln → L1 → Ln - 1 → L2 → Ln - 2 → …
```

不能只是单纯的改变节点内部的值，而是需要实际的进行节点交换。

 **示例 1：** 

![](https://pic.leetcode-cn.com/1626420311-PkUiGI-image.png)

```
输入：head = [1,2,3,4]
输出：[1,4,2,3]
```

 **示例 2：** 

![](https://pic.leetcode-cn.com/1626420320-YUiulT-image.png)

```
输入：head = [1,2,3,4,5]
输出：[1,5,2,4,3]
```

 **提示：** 

*   链表的长度范围为 `[1, 5 * 10^4]`
*   `1 <= node.val <= 1000`

---

本题主要由以下三部分组成：

- **快慢指针**，用于查找中间偏左的节点

- **[反转链表](./206.%20%E5%8F%8D%E8%BD%AC%E9%93%BE%E8%A1%A8.md)**，将原链表的右半部分反转

- **合并链表**，将原链表的左半部分和反转后的右半部分进行穿插合并，这里需要使用额外节点记录当前节点的下一个节点

```java
/**
 * Definition for singly-linked list.
 * public class ListNode {
 *     int val;
 *     ListNode next;
 *     ListNode() {}
 *     ListNode(int val) { this.val = val; }
 *     ListNode(int val, ListNode next) { this.val = val; this.next = next; }
 * }
 */
class Solution {
    public void reorderList(ListNode head) {
        ListNode mid = searchMid(head), second = mid.next;
        mid.next = null;
        second = reverseList(second);
        mergeList(head, second);
    }

    public ListNode searchMid(ListNode head){
        ListNode slow = head, fast = head;
        while(fast.next != null && fast.next.next != null){
            slow = slow.next;
            fast = fast.next.next;
        }
        return slow;
    }

    public ListNode reverseList(ListNode head){
        if(head == null || head.next == null) return head;
        ListNode newHead = reverseList(head.next);
        head.next.next = head;
        head.next = null;
        return newHead;
    }

    public void mergeList(ListNode first, ListNode second){
        ListNode temp1 = null, temp2 = null;
        while(first != null && second != null){
            temp1 = first.next;
            temp2 = second.next;
            first.next = second;
            first.next.next = temp1;
            first = temp1;
            second = temp2;
        }
    }
}
```