#### 23. 合并K个升序链表

难度：困难

---

给你一个链表数组，每个链表都已经按升序排列。

请你将所有链表合并到一个升序链表中，返回合并后的链表。

 **示例 1：** 

```
输入：lists = [[1,4,5],[1,3,4],[2,6]]
输出：[1,1,2,3,4,4,5,6]
解释：链表数组如下：
[
  1->4->5,
  1->3->4,
  2->6
]
将它们合并到一个有序链表中得到。
1->1->2->3->4->4->5->6
```

 **示例 2：** 

```
输入：lists = []
输出：[]
```

 **示例 3：** 

```
输入：lists = [[]]
输出：[]
```

 **提示：** 

*   `k == lists.length`
*   `0 <= k <= 10^4`
*   `0 <= lists[i].length <= 500`
*   `-10^4 <= lists[i][j] <= 10^4`
*   `lists[i]` 按  **升序**  排列
*   `lists[i].length` 的总和不超过 `10^4`

---

本题需要掌握的前提是[合并两个有序链表](https://leetcode.cn/problems/merge-two-sorted-lists/)。

再借助**分治**的思想。注意 merge 的返回值是一条合并后的链表。

```java
/**
 * Definition for singly-linked list.
 * public class ListNode {
 *     int val;
 *     ListNode next;
 *     ListNode() {}
 *     ListNode(int val) { this.val = val; }
 *     ListNode(int val, ListNode next) { this.val = val; this.next = next; }
 * }
 */
class Solution {
    public ListNode mergeKLists(ListNode[] lists) {
        return merge(lists, 0, lists.length - 1);
    }

    private ListNode merge(ListNode[] lists, int left, int right){
        if(right < left) return null;
        if(right == left) return lists[left];
        int mid = (left + right) >>> 1;
        return mergeTwoLists(merge(lists, left, mid), merge(lists, mid + 1, right));
    }

    private ListNode mergeTwoLists(ListNode a, ListNode b){
        if(a == null || b == null){
            return a != null ? a : b;
        }
        ListNode node = new ListNode(0), temp = node;
        while(a != null && b != null){
            if(a.val <= b.val){
                temp.next = a;
                a = a.next;
            }else{
                temp.next = b;
                b = b.next;
            }
            temp = temp.next;
        }
        temp.next = (a != null ? a : b);
        return node.next;
    }
}
```