#### 24. 两两交换链表中的节点

难度：中等

---

给你一个链表，两两交换其中相邻的节点，并返回交换后链表的头节点。你必须在不修改节点内部的值的情况下完成本题（即，只能进行节点交换）。

 **示例 1：** 

![](https://assets.leetcode.com/uploads/2020/10/03/swap_ex1.jpg)
```
输入：head = [1,2,3,4]
输出：[2,1,4,3]
```

 **示例 2：** 

```
输入：head = []
输出：[]
```

 **示例 3：** 

```
输入：head = [1]
输出：[1]
```

 **提示：** 

*   链表中节点的数目在范围 `[0, 100]` 内
*   `0 <= Node.val <= 100`

---

额外定义一个虚拟节点 dummy，使其指向头节点，接着在定义两个节点，分别指向需要交换的第一个节点和第二个节点。在本题中，一定需要**三个节点**，两个节点无法完成。

代码一，除虚拟节点外的剩余两个节点为全局变量。不建议。因为每次赋值都需要判空。

```java
/**
 * Definition for singly-linked list.
 * public class ListNode {
 *     int val;
 *     ListNode next;
 *     ListNode() {}
 *     ListNode(int val) { this.val = val; }
 *     ListNode(int val, ListNode next) { this.val = val; this.next = next; }
 * }
 */
class Solution {
    public ListNode swapPairs(ListNode head) {
        if(head == null) return null;
        ListNode dummy = new ListNode(0);
        dummy.next = head;
        ListNode pre = dummy, first = pre.next, second = first.next;
        while(first != null && second != null){
            pre.next = second;
            first.next = second.next;
            second.next = first;
            pre = first;
            if(pre == null) break;      // 此处需要判断是否为null，因为null没用next指针。
            first = pre.next;
            if(first == null) break;    // 此处需要判断是否为null，因为null没用next指针。
            second = first.next;
        }
        return dummy.next;
    }
}
```

代码二：除虚拟节点外的剩余两个节点为全局变量。建议。代码比较简洁。

```java
/**
 * Definition for singly-linked list.
 * public class ListNode {
 *     int val;
 *     ListNode next;
 *     ListNode() {}
 *     ListNode(int val) { this.val = val; }
 *     ListNode(int val, ListNode next) { this.val = val; this.next = next; }
 * }
 */
class Solution {
    public ListNode swapPairs(ListNode head) {
        ListNode dummy = new ListNode(0);
        dummy.next = head;
        ListNode pre = dummy;
        while(pre.next != null && pre.next.next != null){
            ListNode first = pre.next, second = first.next;
            pre.next = second;
            first.next = second.next;
            second.next = first;
            pre = first;
        }
        return dummy.next;
    }
}
```