#### 328. 奇偶链表

难度：中等

---

给定单链表的头节点 `head` ，将所有索引为奇数的节点和索引为偶数的节点分别组合在一起，然后返回重新排序的列表。

 **第一个** 节点的索引被认为是  **奇数**  ，  **第二个** 节点的索引为  **偶数**  ，以此类推。

请注意，偶数组和奇数组内部的相对顺序应该与输入时保持一致。

你必须在 `O(1)` 的额外空间复杂度和 `O(n)` 的时间复杂度下解决这个问题。

 **示例 1:** 

![](https://assets.leetcode.com/uploads/2021/03/10/oddeven-linked-list.jpg)

```
输入: head = [1,2,3,4,5]
输出: [1,3,5,2,4]
```

 **示例 2:** 

![](https://assets.leetcode.com/uploads/2021/03/10/oddeven2-linked-list.jpg)

```
输入: head = [2,1,3,5,6,4,7]
输出: [2,3,6,7,1,5,4]
```

 **提示:** 

*   `n ==`  链表中的节点数
*   `0 <= n <= 10^4`
*   `-10^6 <= Node.val <= 10^6`

---

双指针：

一个指针指向头节点（代表奇数节点），另一个指针指向头节点的下一个节点（代表偶数节点），接着奇数节点和偶数节点的下一个节点均指向原节点下一个节点的下一个节点（完成节点的跨越）。

因为偶数节点肯定位于奇数节点后，那么循环推出条件只需要判断偶数节点和偶数节点的下一个节点是否为空（通过多次尝试得出的结论），最后退出循环时将两个节点拼接到一起即可。

```Java
/**
 * Definition for singly-linked list.
 * public class ListNode {
 *     int val;
 *     ListNode next;
 *     ListNode() {}
 *     ListNode(int val) { this.val = val; }
 *     ListNode(int val, ListNode next) { this.val = val; this.next = next; }
 * }
 */
class Solution {
    public ListNode oddEvenList(ListNode head) {
        if(head == null || head.next == null) return head;
        ListNode odd = head, even = head.next, temp = even;
        while(even != null && even.next != null){
            odd.next = odd.next.next;
            even.next = even.next.next;
            odd = odd.next;
            even = even.next;
        }
        odd.next = temp;
        return head;
    }
}
```