#### 445. 两数相加 II

难度：中等

---

给你两个  **非空**  链表来代表两个非负整数。数字最高位位于链表开始位置。它们的每个节点只存储一位数字。将这两数相加会返回一个新的链表。

你可以假设除了数字 0 之外，这两个数字都不会以零开头。

 **示例1：** 

![](https://pic.leetcode-cn.com/1626420025-fZfzMX-image.png)

```
输入：l1 = [7,2,4,3], l2 = [5,6,4]
输出：[7,8,0,7]
```

 **示例2：** 

```
输入：l1 = [2,4,3], l2 = [5,6,4]
输出：[8,0,7]
```

 **示例3：** 

```
输入：l1 = [0], l2 = [0]
输出：[0]
```

 **提示：** 

*   链表的长度范围为 `[1, 100]`
*   `0 <= node.val <= 9`
*   输入数据保证链表代表的数字无前导 0

 **进阶：** 如果输入链表不能翻转该如何解决？

---

反转链表 + 两数相加：

思路比较简单，**先反转两个链表，各个位上的数相加后再将链表反转**。中间的一些细节，比如当前两个链表指针都为空但仍有进位时，不能忽略这种情况。

```Java
/**
 * Definition for singly-linked list.
 * public class ListNode {
 *     int val;
 *     ListNode next;
 *     ListNode() {}
 *     ListNode(int val) { this.val = val; }
 *     ListNode(int val, ListNode next) { this.val = val; this.next = next; }
 * }
 */
class Solution {
    public ListNode addTwoNumbers(ListNode l1, ListNode l2) {
        ListNode head1 = reverseListNode(l1), head2 = reverseListNode(l2), dummy = new ListNode(0), cur = dummy;
        int carry = 0;
        while(head1 != null || head2 != null || carry != 0){
            if(head1 != null){
                carry += head1.val;
                head1 = head1.next;
            }
            if(head2 != null) {
                carry += head2.val;
                head2 = head2.next; 
            }
            cur = cur.next = new ListNode(carry % 10);	// Java 连等赋值时自右向左赋值的
            carry /= 10;
        }
        return reverseListNode(dummy.next);
    }

    public ListNode reverseListNode(ListNode head){
        ListNode pre = null, node = head;
        while(node != null){
            ListNode temp = node.next;
            node.next = pre;
            pre = node;
            node = temp;
        }
        return pre;
    }
}
```