#### 450. 删除二叉搜索树中的节点

难度：中等

---

给定一个二叉搜索树的根节点  **root**  和一个值  **key** ，删除二叉搜索树中的  **key**  对应的节点，并保证二叉搜索树的性质不变。返回二叉搜索树（有可能被更新）的根节点的引用。

一般来说，删除节点可分为两个步骤：

1.  首先找到需要删除的节点；
2.  如果找到了，删除它。

 **示例 1:** 

![](https://assets.leetcode.com/uploads/2020/09/04/del_node_1.jpg)

```
输入：root = [5,3,6,2,4,null,7], key = 3
输出：[5,4,6,2,null,null,7]
解释：给定需要删除的节点值是 3，所以我们首先找到 3 这个节点，然后删除它。
一个正确的答案是 [5,4,6,2,null,null,7], 如下图所示。
另一个正确答案是 [5,2,6,null,4,null,7]。
```

 **示例 2:** 

```
输入: root = [5,3,6,2,4,null,7], key = 0
输出: [5,3,6,2,4,null,7]
解释: 二叉树不包含值为 0 的节点
```

 **示例 3:** 

```
输入: root = [], key = 0
输出: []
```

 **提示:** 

*   节点数的范围 `[0, 10^4]`.
*   `-10^5 <= Node.val <= 10^5`
*   节点值唯一
*   `root` 是合法的二叉搜索树
*   `-10^5 <= key <= 10^5`

 **进阶：**  要求算法时间复杂度为 O(h)，h 为树的高度。

---

链表的删除：

将需要删除的节点的左节点连接至右节点的最左节点。

```Java
/**
 * Definition for a binary tree node.
 * public class TreeNode {
 *     int val;
 *     TreeNode left;
 *     TreeNode right;
 *     TreeNode() {}
 *     TreeNode(int val) { this.val = val; }
 *     TreeNode(int val, TreeNode left, TreeNode right) {
 *         this.val = val;
 *         this.left = left;
 *         this.right = right;
 *     }
 * }
 */
class Solution {
    public TreeNode deleteNode(TreeNode root, int key) {
        TreeNode node = root, dummy = new TreeNode(), pre = dummy;
        dummy.left = root;
        boolean isLeft = true;
        while(node !=null && node.val != key){
            pre = node;
            if(node.val < key){
                node = node.right;
                isLeft = false;
            }
            else {
                node = node.left;
                isLeft = true;
            }
        }
        if(node == null) return root;
        jointNode(pre, isLeft);
        return dummy.left;
    }

    private void jointNode(TreeNode pre, boolean isLeft){
        TreeNode left = null, right = null;
        if(isLeft) {
            left = pre.left.left;
            right = pre.left.right;
        } else {
            left = pre.right.left;
            right = pre.right.right;
        }
        if(right == null){
            if(isLeft) pre.left = left;
            else pre.right = left;
        } else {
            TreeNode temp = right;
            while(temp.left != null){
                temp = temp.left;
            }
            temp.left = left;
            if(isLeft) pre.left = right;
            else pre.right = right;
        }

    }
}
```