#### 1653. 使字符串平衡的最少删除次数

难度：中等

---

给你一个字符串 `s` ，它仅包含字符 `'a'` 和 `'b'`​​​​ 。

你可以删除 `s` 中任意数目的字符，使得 `s`  **平衡**  。当不存在下标对 `(i,j)` 满足 `i < j` ，且 `s[i] = 'b'` 的同时 `s[j]= 'a'` ，此时认为 `s` 是  **平衡**  的。

请你返回使 `s`  **平衡**  的  **最少**  删除次数。

 **示例 1：** 

```
输入：s = "aababbab"
输出：2
解释：你可以选择以下任意一种方案：
下标从 0 开始，删除第 2 和第 6 个字符（"aababbab" -> "aaabbb"），
下标从 0 开始，删除第 3 和第 6 个字符（"aababbab" -> "aabbbb"）。
```

 **示例 2：** 

```
输入：s = "bbaaaaabb"
输出：2
解释：唯一的最优解是删除最前面两个字符。
```

 **提示：** 

*   `1 <= s.length <= 10^5`
*   `s[i]` 要么是 `'a'` 要么是 `'b'`​ 。​

---

两次遍历：

第一次从左向右遍历记录所有 `A` 的数量（换言之，右侧 `A` 的数量），第二次从左向右遍历根据不同情况增加左侧 `B` 的数量（当前字符为 `B`）或减少右侧 `A` 的数量（当前字符为 `A`），遍历过程中这两者数量和的最小值即是最后的答案。

类似于前缀和，也类似是求最长非递减子序列长度

```Java
class Solution {
    public int minimumDeletions(String s) {
        int rightA = 0, leftB = 0;
        for(int i = 0; i < s.length(); i++){
            if(s.charAt(i) == 'a') rightA++;
        }
        int ans = rightA;
        for(int i = 0; i < s.length(); i++){
            if(s.charAt(i) == 'a') rightA--;
            else leftB++;
            ans = Math.min(ans, leftB + rightA);
        }
        return ans;
    }
}
```