#### 31. 下一个排列

难度：中等

---

整数数组的一个  **排列**   就是将其所有成员以序列或线性顺序排列。

*   例如，`arr = [1,2,3]` ，以下这些都可以视作 `arr` 的排列：`[1,2,3]`、`[1,3,2]`、`[3,1,2]`、`[2,3,1]` 。

整数数组的  **下一个排列**  是指其整数的下一个字典序更大的排列。更正式地，如果数组的所有排列根据其字典顺序从小到大排列在一个容器中，那么数组的  **下一个排列**  就是在这个有序容器中排在它后面的那个排列。如果不存在下一个更大的排列，那么这个数组必须重排为字典序最小的排列（即，其元素按升序排列）。

*   例如，`arr = [1,2,3]` 的下一个排列是 `[1,3,2]` 。
*   类似地，`arr = [2,3,1]` 的下一个排列是 `[3,1,2]` 。
*   而 `arr = [3,2,1]` 的下一个排列是 `[1,2,3]` ，因为 `[3,2,1]` 不存在一个字典序更大的排列。

给你一个整数数组 `nums` ，找出 `nums` 的下一个排列。

必须  **[原地](https://baike.baidu.com/item/%E5%8E%9F%E5%9C%B0%E7%AE%97%E6%B3%95)**  修改，只允许使用额外常数空间。

 **示例 1：** 

```
输入：nums = [1,2,3]
输出：[1,3,2]
```

 **示例 2：** 

```
输入：nums = [3,2,1]
输出：[1,2,3]
```

 **示例 3：** 

```
输入：nums = [1,1,5]
输出：[1,5,1]
```

 **提示：** 

*   `1 <= nums.length <= 100`
*   `0 <= nums[i] <= 100`

---

算法步骤：

1. 从后往前找到第一个升序的元素对，分别定义其下标为 `index - 1` 和 `index`，即 `nums[index - 1] < nums[i]`
2. 重新从后往前找到第一个大于 `nums[index - 1]` 的元素，定义其下标为 `i`， 即元素为 `nums[i]` 并交换 `nums[index - 1]`
3. 接着反转 `[index , n - 1]` 范围内的所有元素，因为 `[index, n - 1]` 范围内的元素经过第一步筛选后一定是非升序的，下一个更大的排列一定是升序的。

```Java
class Solution {
    public void nextPermutation(int[] nums) {
        int n = nums.length, index = n - 1;
        while(index > 0){
            if(nums[index] > nums[index - 1]){
                break;
            }
            index--;
        }
        if(index != 0){
            for(int i = n - 1; i >= index; i--){
                if(nums[index - 1] < nums[i]){
                    swap(nums, index - 1, i);
                    break;
                }
            }
        }
        int left = index, right = n - 1;
        while(left < right){
            swap(nums, left++, right--);
        }
    }

    private void swap(int[] nums, int i, int j){
        int temp = nums[i];
        nums[i] = nums[j];
        nums[j] = temp;
    }
}
```