#### 36. 有效的数独

难度：中等

---

请你判断一个 `9 x 9` 的数独是否有效。只需要  **根据以下规则**  ，验证已经填入的数字是否有效即可。

1.  数字 `1-9` 在每一行只能出现一次。
2.  数字 `1-9` 在每一列只能出现一次。
3.  数字 `1-9` 在每一个以粗实线分隔的 `3x3` 宫内只能出现一次。（请参考示例图）

 **注意：** 

*   一个有效的数独（部分已被填充）不一定是可解的。
*   只需要根据以上规则，验证已经填入的数字是否有效即可。
*   空白格用 `'.'` 表示。

 **示例 1：** 

![](https://assets.leetcode-cn.com/aliyun-lc-upload/uploads/2021/04/12/250px-sudoku-by-l2g-20050714svg.png)
```
输入：board = 
[["5","3",".",".","7",".",".",".","."]
,["6",".",".","1","9","5",".",".","."]
,[".","9","8",".",".",".",".","6","."]
,["8",".",".",".","6",".",".",".","3"]
,["4",".",".","8",".","3",".",".","1"]
,["7",".",".",".","2",".",".",".","6"]
,[".","6",".",".",".",".","2","8","."]
,[".",".",".","4","1","9",".",".","5"]
,[".",".",".",".","8",".",".","7","9"]]
输出：true
```

 **示例 2：** 

```
输入：board = 
[["8","3",".",".","7",".",".",".","."]
,["6",".",".","1","9","5",".",".","."]
,[".","9","8",".",".",".",".","6","."]
,["8",".",".",".","6",".",".",".","3"]
,["4",".",".","8",".","3",".",".","1"]
,["7",".",".",".","2",".",".",".","6"]
,[".","6",".",".",".",".","2","8","."]
,[".",".",".","4","1","9",".",".","5"]
,[".",".",".",".","8",".",".","7","9"]]
输出：false
解释：除了第一行的第一个数字从 5 改为 8 以外，空格内其他数字均与 示例1 相同。 但由于位于左上角的 3x3 宫内有两个 8 存在, 因此这个数独是无效的。
```

 **提示：** 

*   `board.length == 9`
*   `board[i].length == 9`
*   `board[i][j]` 是一位数字（`1-9`）或者 `'.'`

---

借助三个二维数组分别记录每行、每列、每一个 `3 x 3` 正方形内每个数字出现的次数，如果次数大于 `1`，则是不有效的，否则是有效的。

```java
class Solution {
    public boolean isValidSudoku(char[][] board) {
        int[][] rows = new int[9][10];
        int[][] columns = new int[9][10];
        int[][] squares = new int[9][10];
        for(int i = 0; i < 9; i++){
            for(int j = 0; j < 9; j++){
                char c = board[i][j];
                if(c != '.'){
                    rows[i][c - '0'] += 1;
                    columns[j][c - '0'] += 1;
                    squares[i / 3 * 3 + j / 3][c - '0'] += 1;
                    if(rows[i][c - '0'] > 1 || columns[j][c - '0'] > 1 || squares[i / 3 * 3 + j / 3][c - '0'] > 1) return false;
                }
            }
        }
        return true;
    }
}
```