#### 56. 合并区间

难度：中等

---

以数组 `intervals` 表示若干个区间的集合，其中单个区间为 `intervals[i] = [starti, endi]` 。请你合并所有重叠的区间，并返回 _一个不重叠的区间数组，该数组需恰好覆盖输入中的所有区间_ 。

 **示例 1：** 

```
输入：intervals = [[1,3],[2,6],[8,10],[15,18]]
输出：[[1,6],[8,10],[15,18]]
解释：区间 [1,3] 和 [2,6] 重叠, 将它们合并为 [1,6].
```

 **示例 2：** 

```
输入：intervals = [[1,4],[4,5]]
输出：[[1,5]]
解释：区间 [1,4] 和 [4,5] 可被视为重叠区间。
```

 **提示：** 

*   `1 <= intervals.length <= 10^4`
*   `intervals[i].length == 2`
*   `0 <= starti <= endi <= 10^4`

---

类似贪心：

先按左区间排序，接着分三种情况讨论：

1. 当前的右区间在下一个元素的左区间之前
2. 当前的右区间在下一个元素的左右区间之间
3. 当前的右区间在下一个元素的右区间之后

更简化的方案是将 List 中最后一个元素的右值与当前元素的左值比较。

```Java
class Solution {
    public int[][] merge(int[][] intervals) {
        Arrays.sort(intervals, (int[] a, int[] b) -> (a[0] - b[0]));
        List<int[]> res = new ArrayList<>();
        int index = 0, n = intervals.length;
        while(index < n){
            int start = intervals[index][0], end = intervals[index][1];
            if(res.size() == 0 || res.get(res.size() - 1)[1] < start){
                res.add(new int[]{start, end});
            } else {
                res.get(res.size() - 1)[1] = Math.max(res.get(res.size() - 1)[1], end);
            }
            index++;
        }
        return res.toArray(new int[res.size()][2]);
    }
}
```