#### 89. 格雷编码

难度：中等

---

 **n 位格雷码序列**  是一个由 `2^n` 个整数组成的序列，其中：

*   每个整数都在范围 `[0, 2^n - 1]` 内（含 `0` 和 `2^n - 1`）
*   第一个整数是 `0`
*   一个整数在序列中出现  **不超过一次** 
*   每对  **相邻**  整数的二进制表示  **恰好一位不同**  ，且
*    **第一个**  和  **最后一个**  整数的二进制表示  **恰好一位不同** 

给你一个整数 `n` ，返回任一有效的  **n 位格雷码序列**  。

 **示例 1：** 

```
输入：n = 2
输出：[0,1,3,2]
解释：
[0,1,3,2] 的二进制表示是 [00,01,11,10] 。
- 00 和 01 有一位不同
- 01 和 11 有一位不同
- 11 和 10 有一位不同
- 10 和 00 有一位不同
[0,2,3,1] 也是一个有效的格雷码序列，其二进制表示是 [00,10,11,01] 。
- 00 和 10 有一位不同
- 10 和 11 有一位不同
- 11 和 01 有一位不同
- 01 和 00 有一位不同
```

 **示例 2：** 

```
输入：n = 1
输出：[0,1]
```

 **提示：** 

*   `1 <= n <= 16`

---

找规律：

通过规律发现，根据前 `k` 位的格雷码通过**对称**的方式可以构造出 `k + 1` 位的格雷码。例如，

```
0 0 0
0 0 1
0 1 1
0 1 0
1 1 0
1 1 1
1 0 1
1 0 0
```

前两行的后一位（0，1）对称可得到第三四行的后一位（1，0），前四行的后两位（00，01，11，10）对称可得到第五至八行的后两位（10，11，01，00）。

```Java
class Solution {
    public List<Integer> grayCode(int n) {
        List<Integer> ans = new ArrayList<>();
        ans.add(0);
        int head = 1;
        for(int i = 0; i < n; i++){
            for(int j = ans.size() - 1; j >= 0; j--){
                ans.add(head + ans.get(j));
            }
            head <<= 1;
        }
        return ans;
    }
}
```