#### 916. 单词子集

难度：中等

---

给你两个字符串数组 `words1` 和 `words2`。

现在，如果 `b` 中的每个字母都出现在 `a` 中， **包括重复出现的字母** ，那么称字符串 `b` 是字符串 `a` 的  **子集**  。

*   例如，`"wrr"` 是 `"warrior"` 的子集，但不是 `"world"` 的子集。

如果对 `words2` 中的每一个单词 `b`，`b` 都是 `a` 的子集，那么我们称 `words1` 中的单词 `a` 是  **通用单词**  。

以数组形式返回 `words1` 中所有的通用单词。你可以按  **任意顺序**  返回答案。

 **示例 1：** 

```
输入：words1 = ["amazon","apple","facebook","google","leetcode"], words2 = ["e","o"]
输出：["facebook","google","leetcode"]
```

 **示例 2：** 

```
输入：words1 = ["amazon","apple","facebook","google","leetcode"], words2 = ["l","e"]
输出：["apple","google","leetcode"]
```

 **示例 3：** 

```
输入：words1 = ["amazon","apple","facebook","google","leetcode"], words2 = ["e","oo"]
输出：["facebook","google"]
```

 **示例 4：** 

```
输入：words1 = ["amazon","apple","facebook","google","leetcode"], words2 = ["lo","eo"]
输出：["google","leetcode"]
```

 **示例 5：** 

```
输入：words1 = ["amazon","apple","facebook","google","leetcode"], words2 = ["ec","oc","ceo"]
输出：["facebook","leetcode"]
```

 **提示：** 

*   `1 <= words1.length, words2.length <= 10^4`
*   `1 <= words1[i].length, words2[i].length <= 10`
*   `words1[i]` 和 `words2[i]` 仅由小写英文字母组成
*   `words1` 中的所有字符串  **互不相同**

---

失败：

类似于暴力解法，有三重循环。

```java
class Solution {
    public List<String> wordSubsets(String[] words1, String[] words2) {
        ArrayList<String> ans = new ArrayList<>();
        for(int i = 0; i < words1.length; i++){
            int flag = 0;
            for(int j = 0; j < words2.length; j++){
                HashMap<Character, Integer> map = new HashMap<>();
                for(int k = 0; k < words2[j].length(); k++){
                    int index = words1[i].indexOf(words2[j].charAt(k), map.getOrDefault(words2[j].charAt(k), 0));
                    if(index < 0) flag = 1;
                    else map.put(words2[j].charAt(k), index + 1);
                }

            }
            if(flag == 0) ans.add(words1[i]);
        }
        return ans;
    }
}
```



成功：

先处理 `word2` 的内容，也就是统计 `word2` 中每个字符的最高频率，得到**频率表**，接着将其与 `word1` 里字符串的频率进行比较。

```java
class Solution {
    public List<String> wordSubsets(String[] words1, String[] words2) {
        ArrayList<String> ans = new ArrayList<>();
        int[] count = new int[26];
        for(int i = 0; i < words2.length; i++){
            int[] temp = new int[26];
            for(int j = 0; j < words2[i].length(); j++) temp[words2[i].charAt(j) - 'a']++;
            for(int j = 0; j < 26; j++) count[j] = Math.max(count[j], temp[j]);
        }
        for(int i = 0; i < words1.length; i++){
            int flag = 0;
            int[] temp = new int[26];
            for(int j = 0; j < words1[i].length(); j++) temp[words1[i].charAt(j) - 'a']++;
            for(int j = 0; j < 26; j++){
                if(count[j] != 0 && temp[j] < count[j]) flag = 1;	// word2 中频率不为 0 的字符并且该字符的频率大于在 word1 中的频率时，不符合条件
            }
            if(flag == 0) ans.add(words1[i]);
        }
        return ans;
    }
}
```

