#### 42. 接雨水

难度：困难

---

给定 `n` 个非负整数表示每个宽度为 `1` 的柱子的高度图，计算按此排列的柱子，下雨之后能接多少雨水。

 **示例 1：** 

![](https://assets.leetcode-cn.com/aliyun-lc-upload/uploads/2018/10/22/rainwatertrap.png)

```
输入：height = [0,1,0,2,1,0,1,3,2,1,2,1]
输出：6
解释：上面是由数组 [0,1,0,2,1,0,1,3,2,1,2,1] 表示的高度图，在这种情况下，可以接 6 个单位的雨水（蓝色部分表示雨水）。
```

 **示例 2：** 

```
输入：height = [4,2,0,3,2,5]
输出：9
```

 **提示：** 

*   `n == height.length`
*   `1 <= n <= 2 * 10^4`
*   `0 <= height[i] <= 10^5`

---

单调栈：

栈中存放的是下标，但其下标对应的高度是递减的。

因为从左至右遍历的过程中如果当前下标元素( `height[i]` )比栈顶元素( `height[top]` )大，那么循环弹出栈顶元素并计算栈顶元素与当前下标可以接的雨水直至栈顶元素大于当前下标元素。

```java
class Solution {
    public int trap(int[] height) {
        int n = height.length, ans = 0;
        ArrayDeque<Integer> stack = new ArrayDeque<>();
        for(int i = 0; i < n; i++){
            while(!stack.isEmpty() && height[i] > height[stack.peek()]){
                int top = stack.pop();
                if(stack.isEmpty()) break;
                int left = stack.peek();
                int curHeight = Math.min(height[i], height[left]) - height[top];
                int curWidth = i - left - 1;
                ans += curHeight * curWidth;
            }
            stack.push(i);
        }
        return ans;
    }
}
```