#### 503. 下一个更大元素 II

难度：中等

---

给定一个循环数组 `nums` （ `nums[nums.length - 1]` 的下一个元素是 `nums[0]` ），返回 _`nums` 中每个元素的  **下一个更大元素** _ 。

数字 `x` 的  **下一个更大的元素**  是按数组遍历顺序，这个数字之后的第一个比它更大的数，这意味着你应该循环地搜索它的下一个更大的数。如果不存在，则输出 `-1` 。

 **示例 1:** 

```
输入: nums = [1,2,1]
输出: [2,-1,2]
解释: 第一个 1 的下一个更大的数是 2；
数字 2 找不到下一个更大的数； 
第二个 1 的下一个最大的数需要循环搜索，结果也是 2。
```

 **示例 2:** 

```
输入: nums = [1,2,3,4,3]
输出: [2,3,4,-1,4]
```

 **提示:** 

*   `1 <= nums.length <= 10^4`
*   `-10^9 <= nums[i] <= 10^9`

---

法一，单调栈 + 扩展两倍数组：

使用 `System.array(source_arr, sourcePos, dest_arr, destPos, len)` 方法扩展数组，该方法也可应用到其他循环数组的题目中。

```java
class Solution {
    public int[] nextGreaterElements(int[] nums) {
        int n = nums.length;
        int[] ans = new int[n];
        int[] doubleNums = new int[2 * n];
        System.arraycopy(nums, 0, doubleNums, 0, n);
        System.arraycopy(nums, 0, doubleNums, n, n);
        ArrayDeque<Integer> stack = new ArrayDeque<>();
        for(int i = 2 * n - 1; i >= 0; i--){
            while(!stack.isEmpty() && stack.peek() <= doubleNums[i]) stack.pop();
            if(i < n) ans[i] = stack.isEmpty() ? -1 : stack.peek();
            stack.push(doubleNums[i]);
        }
        return ans;
    }
}
```



法二，单调栈 + 下标取余：

与上述类似的是，两种方法从某种意义上都是扩展两倍数组。

```java
class Solution {
    public int[] nextGreaterElements(int[] nums) {
        int n = nums.length;
        int[] ans = new int[n];
        ArrayDeque<Integer> stack = new ArrayDeque<>();
        for(int i = 2 * n - 1; i >= 0; i--){
            while(!stack.isEmpty() && stack.peek() <= nums[i % n]) stack.pop();
            ans[i % n] = stack.isEmpty() ? -1 : stack.peek();
            stack.push(nums[i % n]);
        }
        return ans;
    }
}
```