#### 739. 每日温度

难度：中等

---

给定一个整数数组 `temperatures` ，表示每天的温度，返回一个数组 `answer` ，其中 `answer[i]` 是指对于第 `i` 天，下一个更高温度出现在几天后。如果气温在这之后都不会升高，请在该位置用 `0` 来代替。

 **示例 1:** 

```
输入: temperatures = [73,74,75,71,69,72,76,73]
输出: [1,1,4,2,1,1,0,0]
```

 **示例 2:** 

```
输入: temperatures = [30,40,50,60]
输出: [1,1,1,0]
```

 **示例 3:** 

```
输入: temperatures = [30,60,90]
输出: [1,1,0]
```

 **提示：** 

*   `1 <= temperatures.length <= 10^5`
*   `30 <= temperatures[i] <= 100`

---

方法一，动态规划 + 双指针：

从后向前遍历，在每个循环中会**跳过一定的区域**，思路类似于[这个](https://leetcode.cn/problems/daily-temperatures/solution/jie-ti-si-lu-by-pulsaryu/)。

时间复杂度$O(N)$，空间复杂度$O(N)$。

![](https://raw.githubusercontent.com/CompetitiveLin/ImageHostingService/picgo/imgs/202304091057244.png)

```Java
class Solution {
    public int[] dailyTemperatures(int[] temperatures) {
        int n = temperatures.length;
        int[] dp = new int[n];
        dp[n - 1] = 0;
        for(int i = n - 2; i >= 0; i--){
            int index = i + 1, cnt = 1;
            while(dp[index] != 0 && temperatures[index] <= temperatures[i]){
                cnt += dp[index];
                index += dp[index];
            }
            if(temperatures[index] <= temperatures[i]) dp[i] = 0;
            else dp[i] = cnt;
        }
        return dp;
    }
}
```

方法二，单调栈：

维护一个存储下标的单调栈，**从栈底到栈顶的下标对应的温度列表中的温度依次递减**。如果一个下标在单调栈里，则表示尚未找到下一次温度更高的下标。每次弹出栈中的元素（下标），都能得到该下标的答案（下一次温度更高的下标，为当前下标减去弹出元素的下标）。

```java
class Solution {
    public int[] dailyTemperatures(int[] temperatures) {
        int n = temperatures.length;
        ArrayDeque<Integer> stack = new ArrayDeque<>();
        int[] ans = new int[n];
        for(int i = 0; i < n; i++){
            while(!stack.isEmpty() && temperatures[i] > temperatures[stack.peek()]){
                ans[stack.peek()] = i - stack.pop();
            }
            stack.push(i);
        }
        return ans;
    }
}
```

