#### 1171. 从链表中删去总和值为零的连续节点

难度：中等

---

给你一个链表的头节点 `head`，请你编写代码，反复删去链表中由  **总和**  值为 `0` 的连续节点组成的序列，直到不存在这样的序列为止。

删除完毕后，请你返回最终结果链表的头节点。

你可以返回任何满足题目要求的答案。

（注意，下面示例中的所有序列，都是对 `ListNode` 对象序列化的表示。）

 **示例 1：** 

```
输入：head = [1,2,-3,3,1]
输出：[3,1]
提示：答案 [1,2,1] 也是正确的。
```

 **示例 2：** 

```
输入：head = [1,2,3,-3,4]
输出：[1,2,4]
```

 **示例 3：** 

```
输入：head = [1,2,3,-3,-2]
输出：[1]
```

 **提示：** 

*   给你的链表中可能有 `1` 到 `1000` 个节点。
*   对于链表中的每个节点，节点的值：`-1000 <= node.val <= 1000`.

---

哈希表 + 前缀和：

删去**连续节点组成的序列**，应该要想到前缀和。

并且需要两次遍历：第一次遍历记录当前前缀和的最后节点以哈希表的数据结构存储；第二次遍历从哈希表中取出相应节点，当前节点的下一个节点是哈希表中的节点的下一个节点（同样适用于当前节点！）。

此外，需要一个 dummy 节点，其节点的下一个节点指向 `head` 节点，以解决 `[1, -1]` 的情况！

```Java
/**
 * Definition for singly-linked list.
 * public class ListNode {
 *     int val;
 *     ListNode next;
 *     ListNode() {}
 *     ListNode(int val) { this.val = val; }
 *     ListNode(int val, ListNode next) { this.val = val; this.next = next; }
 * }
 */
class Solution {
    public ListNode removeZeroSumSublists(ListNode head) {
        HashMap<Integer, ListNode> hashmap = new HashMap<>();
        ListNode dummy = new ListNode(0);
        dummy.next = head;
        int presum = 0;
        for(ListNode temp = dummy; temp != null; temp = temp.next){
            presum += temp.val;
            hashmap.put(presum, temp);
        }
        presum = 0;
        for(ListNode temp = dummy; temp != null; temp = temp.next){
            presum += temp.val;
            temp.next = hashmap.get(presum).next;
        }
        return dummy.next;
    }
}
```