#### 53. 最大子数组和

难度：中等

---

给你一个整数数组 `nums` ，请你找出一个具有最大和的连续子数组（子数组最少包含一个元素），返回其最大和。

 **子数组**  是数组中的一个连续部分。

 **示例 1：** 

```
输入：nums = [-2,1,-3,4,-1,2,1,-5,4]
输出：6
解释：连续子数组 [4,-1,2,1] 的和最大，为 6 。
```

 **示例 2：** 

```
输入：nums = [1]
输出：1
```

 **示例 3：** 

```
输入：nums = [5,4,-1,7,8]
输出：23
```

 **提示：** 

*   `1 <= nums.length <= 10^5`
*   `-10^4 <= nums[i] <= 10^4`

 **进阶：** 如果你已经实现复杂度为 `O(n)` 的解法，尝试使用更为精妙的  **分治法**  求解。

---

前缀和：

顺序遍历并记录前缀和的最小值，与当前前缀和进行对比，取差值最大的即可。注意的是**前缀和数组长度为原数组长度 + 1**。

```Java
class Solution {
    public int maxSubArray(int[] nums) {
        int n = nums.length;
        int[] prefix = new int[n + 1];
        int current = 0, res = nums[0];
        for(int i = 1; i < n + 1; i++){
            prefix[i] = prefix[i - 1] + nums[i - 1];
            res = Math.max(res, prefix[i] - current);
            current = Math.min(current, prefix[i]);
        }
        return res;
    }
}
```