#### 1054. 距离相等的条形码

难度：中等

---

在一个仓库里，有一排条形码，其中第 `i` 个条形码为 `barcodes[i]`。

请你重新排列这些条形码，使其中任意两个相邻的条形码不能相等。 你可以返回任何满足该要求的答案，此题保证存在答案。

 **示例 1：** 

```
输入：barcodes = [1,1,1,2,2,2]
输出：[2,1,2,1,2,1]
```

 **示例 2：** 

```
输入：barcodes = [1,1,1,1,2,2,3,3]
输出：[1,3,1,3,2,1,2,1]
```

 **提示：** 

*   `1 <= barcodes.length <= 10000`
*   `1 <= barcodes[i] <= 10000`

---

哈希表 + 优先队列：

最初的思路：找到剩余数量最多的元素并尽可能优先排列。

借助优先队列（最大堆），每次取优先队列（最大堆）中**剩余数量最多**和**第二多**的元素放入数组中，保证了相邻元素不重复。再考虑一下特殊情况，原数组的个数为奇数个时，意味着最后一个的元素直接放在数组的最后一个即可。

```Java
class Solution {
    public int[] rearrangeBarcodes(int[] barcodes) {
        int n = barcodes.length;
        HashMap<Integer, Integer> hashmap = new HashMap<>();
        for(int barcode: barcodes){
            hashmap.put(barcode, hashmap.getOrDefault(barcode, 0) + 1);
        }
        PriorityQueue<Integer> pq = new PriorityQueue<>((a, b) -> (hashmap.get(b) - hashmap.get(a)));
        for(Integer i: hashmap.keySet()){
            pq.add(i);
        }
        int[] ans = new int[n];
        for(int i = 0; i < n; i += 2){
            if(i == n - 1){
                ans[i] = pq.poll();
            } else {
                int temp1 = pq.poll(), temp2 = pq.poll();
                ans[i] = temp1;
                ans[i + 1] = temp2;
                if(hashmap.get(temp1) > 1){
                    hashmap.put(temp1, hashmap.get(temp1) - 1);
                    pq.add(temp1);
                }
                if(hashmap.get(temp2) > 1){
                    hashmap.put(temp2, hashmap.get(temp2) - 1);
                    pq.add(temp2);
                }
            }
        }
        return ans;
    }
}
```