#### 1792. 最大平均通过率

难度：中等

---

一所学校里有一些班级，每个班级里有一些学生，现在每个班都会进行一场期末考试。给你一个二维数组 `classes` ，其中 `classes[i] = [passi, totali]` ，表示你提前知道了第 `i` 个班级总共有 `totali` 个学生，其中只有 `passi` 个学生可以通过考试。

给你一个整数 `extraStudents` ，表示额外有 `extraStudents` 个聪明的学生，他们  **一定**  能通过任何班级的期末考。你需要给这 `extraStudents` 个学生每人都安排一个班级，使得  **所有**  班级的  **平均**  通过率  **最大**  。

一个班级的  **通过率**  等于这个班级通过考试的学生人数除以这个班级的总人数。 **平均通过率**  是所有班级的通过率之和除以班级数目。

请你返回在安排这 `extraStudents` 个学生去对应班级后的  **最大**  平均通过率。与标准答案误差范围在 `10^-5` 以内的结果都会视为正确结果。

 **示例 1：** 

```
输入：classes = [[1,2],[3,5],[2,2]], extraStudents = 2
输出：0.78333
解释：你可以将额外的两个学生都安排到第一个班级，平均通过率为 (3/4 + 3/5 + 2/2) / 3 = 0.78333 。
```

 **示例 2：** 

```
输入：classes = [[2,4],[3,9],[4,5],[2,10]], extraStudents = 4
输出：0.53485
```

 **提示：** 

*   `1 <= classes.length <= 10^5`
*   `classes[i].length == 2`
*   `1 <= passi <= totali <= 10^5`
*   `1 <= extraStudents <= 10^5`

---

优先队列（增量大顶堆）：

计算 `classes` 里每个班级考试通过率的**增量值**，存入优先队列中，每次取增量最大的一组通过率并安排一位聪明的学生，再重新计算考试通过率并存入优先队列中。直到聪明的学生都被分配完为止。

```java
class Solution {
    public double maxAverageRatio(int[][] classes, int extraStudents) {
        PriorityQueue<int[]> pq = new PriorityQueue<>((a, b) ->{
            double temp1 = (a[0] + 1) * 1.0 / (a[1] + 1) - a[0] * 1.0 / a[1];
            double temp2 = (b[0] + 1) * 1.0 / (b[1] + 1) - b[0] * 1.0 / b[1];
            return Double.compare(temp2, temp1);
        });
        for(int[] temp: classes){
            pq.offer(temp);
        }
        while(extraStudents-- != 0){
            int[] temp = pq.poll();
            temp[0]++;
            temp[1]++;
            pq.offer(temp);
        }
        double ans = 0.0;
        while(!pq.isEmpty()){
            int[] temp = pq.poll();
            ans += temp[0] * 1.0 / temp[1];
        }
        return ans / classes.length;
    }
}
```

注意：

- `public static int compare(double num1, double num2)`，用法：`Double.compare(d1, d2)`
- `public int compareTo(Double anotherDouble)`，用法：`D1.compareTo(D2)`

使用方法2需要**手动装箱**。