#### 692. 前K个高频单词

难度：中等

---

给定一个单词列表 `words` 和一个整数 `k` ，返回前 `k` 个出现次数最多的单词。

返回的答案应该按单词出现频率由高到低排序。如果不同的单词有相同出现频率，  **按字典顺序**  排序。

 **示例 1：** 

```
输入: words = ["i", "love", "leetcode", "i", "love", "coding"], k = 2
输出: ["i", "love"]
解析: "i" 和 "love" 为出现次数最多的两个单词，均为2次。
    注意，按字母顺序 "i" 在 "love" 之前。
```

 **示例 2：** 

```
输入: ["the", "day", "is", "sunny", "the", "the", "the", "sunny", "is", "is"], k = 4
输出: ["the", "is", "sunny", "day"]
解析: "the", "is", "sunny" 和 "day" 是出现次数最多的四个单词，
    出现次数依次为 4, 3, 2 和 1 次。
```

 **注意：** 

*   `1 <= words.length <= 500`
*   `1 <= words[i] <= 10`
*   `words[i]` 由小写英文字母组成。
*   `k` 的取值范围是 `[1,  **不同**  words[i] 的数量]`

 **进阶：** 尝试以 `O(n log k)` 时间复杂度和 `O(n)` 空间复杂度解决。

---

哈希表 + 优先队列：“求前 `k` 个”这类题型都是和最大或最小堆相关联。同样，本题维护的是一个大小为 `K` 的最小堆，并且每次弹出的都是堆中频率最低或字典序大（频率相等时）的字符串。因此在堆的自定义排序实现中，需要考虑这两种情况。

这里需要记住的是，**在自定义排序中 `return a - b` 后的顺序是 `a < b`，即升序，不管是字典序还是数值都适用；如果是 `return b - a`，也就是 `return - (a - b)`，即 `a > b`，降序。**

```java
class Solution {
    public List<String> topKFrequent(String[] words, int k) {
        HashMap<String, Integer> map = new HashMap<>();
        for(String word: words){
            map.put(word, map.getOrDefault(word, 0) + 1);
        }
        PriorityQueue<String> pq = new PriorityQueue<>((s1, s2) -> {
            if(map.get(s1) == map.get(s2)) return -s1.compareTo(s2);	// 字典序大
            return map.get(s1) - map.get(s2);	// 频率低
        });
        for(String key: map.keySet()){
            pq.offer(key);
            if(pq.size() > k) pq.poll();
        }
        List<String> ans = new ArrayList<>();
        while(pq.size() > 0) ans.add(pq.poll());
        Collections.reverse(ans);
        return ans;
    }
}
```

