#### 743. 网络延迟时间

难度：中等

---

有 `n` 个网络节点，标记为 `1` 到 `n`。

给你一个列表 `times`，表示信号经过  **有向**  边的传递时间。 `times[i] = (ui, vi, wi)`，其中 `ui` 是源节点，`vi` 是目标节点， `wi` 是一个信号从源节点传递到目标节点的时间。

现在，从某个节点 `K` 发出一个信号。需要多久才能使所有节点都收到信号？如果不能使所有节点收到信号，返回 `-1` 。

 **示例 1：** 

![](https://assets.leetcode.com/uploads/2019/05/23/931_example_1.png)

```
输入：times = [[2,1,1],[2,3,1],[3,4,1]], n = 4, k = 2
输出：2
```

 **示例 2：** 

```
输入：times = [[1,2,1]], n = 2, k = 1
输出：1
```

 **示例 3：** 

```
输入：times = [[1,2,1]], n = 2, k = 2
输出：-1
```

 **提示：** 

*   `1 <= k <= n <= 100`
*   `1 <= times.length <= 6000`
*   `times[i].length == 3`
*   `1 <= ui, vi <= n`
*   `ui != vi`
*   `0 <= wi <= 100`
*   所有 `(ui, vi)` 对都  **互不相同** （即，不含重复边）

---

Dijkstra算法 + 堆优化：模板题

```java
class Solution {
    public int networkDelayTime(int[][] times, int n, int k) {
        final int INF = Integer.MAX_VALUE / 2;
        int[] dis = new int[n];
        Arrays.fill(dis, INF);
        int[][] g = new int[n][n];
        for(int i = 0; i < n; i++){
            Arrays.fill(g[i], INF);
        }
        for(int[] time: times){
            g[time[0]- 1][time[1] - 1] = time[2];
        }
        PriorityQueue<int[]> minHeap = new PriorityQueue<>((a,b) -> (a[0] - b[0]));	// [distance, node]
        dis[k - 1] = 0;
        minHeap.add(new int[] {0, k - 1});
        while(!minHeap.isEmpty()){
            int[] temp = minHeap.poll();
            int temp_dis = temp[0], temp_node = temp[1];
            if(temp_dis > dis[temp_node]) continue;	// pruning
            for(int i = 0; i < n; i++){
                if(g[temp_node][i] != INF){
                    if(temp_dis + g[temp_node][i] < dis[i]){
                        minHeap.add(new int[] {temp_dis + g[temp_node][i], i});
                        dis[i] = temp_dis + g[temp_node][i];
                    }
                }
            }
        }
        int ans = 0;
        for(int d: dis){
            ans = Math.max(ans, d);
        }
        return ans == INF ? -1 : ans;
    }
}
```

