#### 787. K 站中转内最便宜的航班

难度：中等

---

有 `n` 个城市通过一些航班连接。给你一个数组 `flights` ，其中 `flights[i] = [fromi, toi, pricei]` ，表示该航班都从城市 `fromi` 开始，以价格 `pricei` 抵达 `toi`。

现在给定所有的城市和航班，以及出发城市 `src` 和目的地 `dst`，你的任务是找到出一条最多经过 `k` 站中转的路线，使得从 `src` 到 `dst` 的  **价格最便宜**  ，并返回该价格。 如果不存在这样的路线，则输出 `-1`。

 **示例 1：** 

```
输入: 
n = 3, edges = [[0,1,100],[1,2,100],[0,2,500]]
src = 0, dst = 2, k = 1
输出: 200
解释: 
城市航班图如下


从城市 0 到城市 2 在 1 站中转以内的最便宜价格是 200，如图中红色所示。
```

![img](https://s3-lc-upload.s3.amazonaws.com/uploads/2018/02/16/995.png) 

**示例 2：** 

```
输入: 
n = 3, edges = [[0,1,100],[1,2,100],[0,2,500]]
src = 0, dst = 2, k = 0
输出: 500
解释: 
城市航班图如下


从城市 0 到城市 2 在 0 站中转以内的最便宜价格是 500，如图中蓝色所示。
```

![img](https://s3-lc-upload.s3.amazonaws.com/uploads/2018/02/16/995.png)

 **提示：** 

*   `1 <= n <= 100`
*   `0 <= flights.length <= (n * (n - 1) / 2)`
*   `flights[i].length == 3`
*   `0 <= fromi, toi < n`
*   `fromi != toi`
*   `1 <= pricei <= 10^4`
*   航班没有重复，且不存在自环
*   `0 <= src, dst, k < n`
*   `src != dst`

---

Dijkstra算法 + 堆优化：将【节点，距离和中转次数】一起存入堆中，如果中转次数小于零则放弃当前情况。如果经过同一点的中转次数少但是距离增大，也需要存入堆中一起考虑，因此不能剪枝（`if(cur_dis > dis[cur_point]) continue;`）。直到堆为空，此时返回 `-1`。

```java
class Solution {
    public int findCheapestPrice(int n, int[][] flights, int src, int dst, int k) {
        final int INF = Integer.MAX_VALUE / 2;
        int[][] g = new int[n][n];
        for(int i = 0; i < n; i++){
            Arrays.fill(g[i], INF);
        }
        for(int[] flight: flights){
            g[flight[0]][flight[1]] = flight[2];
        }
        int[] dis = new int[n];
        int[] stops = new int[n];
        Arrays.fill(dis, INF);
        PriorityQueue<int[]> minHeap = new PriorityQueue<>((a,b) -> (a[0] - b[0]));
        minHeap.add(new int[] {0, src, k});
        while(!minHeap.isEmpty()){
            int[] temp = minHeap.poll();
            int cur_dis = temp[0], cur_point = temp[1], cur_stop = temp[2];
            if(cur_point == dst) return cur_dis;
            if(cur_stop < 0) continue;
            // if(cur_dis > dis[cur_point]) continue; // CAN'T DO PRUNING
            for(int i = 0; i < n; i++){
                if(g[cur_point][i] != INF){
                    int cost = g[cur_point][i] + cur_dis;
                    if(cost < dis[i]){
                        dis[i] = cost;
                        stops[i] = cur_stop - 1;
                        minHeap.add(new int[] {cost, i, cur_stop - 1});
                    }
                    else if(cur_stop - 1 > stops[i]){
                        minHeap.add(new int[] {cost, i, cur_stop - 1});
                    }
                }
            }
        }
        return -1;
    }
}
```

