#### 1419. 数青蛙

难度：中等

---

给你一个字符串 `croakOfFrogs`，它表示不同青蛙发出的蛙鸣声（字符串 `"croak"` ）的组合。由于同一时间可以有多只青蛙呱呱作响，所以 `croakOfFrogs` 中会混合多个 `“croak”` _。_

请你返回模拟字符串中所有蛙鸣所需不同青蛙的最少数目。

要想发出蛙鸣 "croak"，青蛙必须  **依序**  输出 `‘c’, ’r’, ’o’, ’a’, ’k’` 这 5 个字母。如果没有输出全部五个字母，那么它就不会发出声音。如果字符串 `croakOfFrogs` 不是由若干有效的 "croak" 字符混合而成，请返回 `-1` 。

 **示例 1：** 

```
输入：croakOfFrogs = "croakcroak"
输出：1 
解释：一只青蛙 “呱呱” 两次
```

 **示例 2：** 

```
输入：croakOfFrogs = "crcoakroak"
输出：2 
解释：最少需要两只青蛙，“呱呱” 声用黑体标注
第一只青蛙 "crcoakroak"
第二只青蛙 "crcoakroak"
```

 **示例 3：** 

```
输入：croakOfFrogs = "croakcrook"
输出：-1
解释：给出的字符串不是 "croak" 的有效组合。
```

 **提示：** 

*   `1 <= croakOfFrogs.length <= 10^5`
*   字符串中的字符只有 `'c'`, `'r'`, `'o'`, `'a'` 或者 `'k'`

---

模拟：

方法比较巧妙，遍历字符串，如果当前字符为 `c`，意味着当前青蛙数加一；如果为 `k`，则当前青蛙数减一；其他只需要考虑字符串不是由若干有效的 `croak` 字符混合而成的情况即可。

```Java
class Solution {
    public int minNumberOfFrogs(String croakOfFrogs) {
        int n = croakOfFrogs.length();
        if(n % 5 != 0) return -1;
        int[] temp = new int[5];
        int ans = 0, cur_num = 0;
        for(int i = 0; i < n; i++){
            char c = croakOfFrogs.charAt(i);
            int index = 0;
            if(c == 'r') index = 1;
            else if(c == 'o') index = 2;
            else if(c == 'a') index = 3;
            else if(c == 'k') index = 4;
            temp[index]++;
            if(index == 0){
                cur_num++;
                ans = Math.max(ans, cur_num);
            }
            else if(index == 4) cur_num--;
            if(index != 0 && temp[index] > temp[index - 1]) return -1;
        }
        for(int i = 0; i < 5; i++) if(temp[i] != n / 5) return -1;
        return ans;
    }
}
```