#### 289. 生命游戏

难度：中等

---

根据 [百度百科](https://baike.baidu.com/item/%E7%94%9F%E5%91%BD%E6%B8%B8%E6%88%8F/2926434?fr=aladdin) ，  **生命游戏**  ，简称为  **生命**  ，是英国数学家约翰·何顿·康威在 1970 年发明的细胞自动机。

给定一个包含 `m × n` 个格子的面板，每一个格子都可以看成是一个细胞。每个细胞都具有一个初始状态： `1` 即为  **活细胞**  （live），或 `0` 即为  **死细胞**  （dead）。每个细胞与其八个相邻位置（水平，垂直，对角线）的细胞都遵循以下四条生存定律：

1.  如果活细胞周围八个位置的活细胞数少于两个，则该位置活细胞死亡；
2.  如果活细胞周围八个位置有两个或三个活细胞，则该位置活细胞仍然存活；
3.  如果活细胞周围八个位置有超过三个活细胞，则该位置活细胞死亡；
4.  如果死细胞周围正好有三个活细胞，则该位置死细胞复活；

下一个状态是通过将上述规则同时应用于当前状态下的每个细胞所形成的，其中细胞的出生和死亡是同时发生的。给你 `m x n` 网格面板 `board` 的当前状态，返回下一个状态。

 **示例 1：** 

![](https://assets.leetcode.com/uploads/2020/12/26/grid1.jpg)
```
输入：board = [[0,1,0],[0,0,1],[1,1,1],[0,0,0]]
输出：[[0,0,0],[1,0,1],[0,1,1],[0,1,0]]
```

 **示例 2：** 

![](https://assets.leetcode.com/uploads/2020/12/26/grid2.jpg)
```
输入：board = [[1,1],[1,0]]
输出：[[1,1],[1,1]]
```

 **提示：** 

*   `m == board.length`
*   `n == board[i].length`
*   `1 <= m, n <= 25`
*   `board[i][j]` 为 `0` 或 `1`

 **进阶：** 

*   你可以使用原地算法解决本题吗？请注意，面板上所有格子需要同时被更新：你不能先更新某些格子，然后使用它们的更新后的值再更新其他格子。
*   本题中，我们使用二维数组来表示面板。原则上，面板是无限的，但当活细胞侵占了面板边界时会造成问题。你将如何解决这些问题？

---

模拟：

原地变换。

- 如果原来是活细胞，后来是死细胞，则赋值为 `2`。

- 如果原来是死细胞，后来是活细胞，则赋值为 `-1`。

遍历时只要其值大于零，原来就是活细胞。

```Java
class Solution {
    public void gameOfLife(int[][] board) {
        int m = board.length, n = board[0].length;
        int[] bias = {-1, 0, 1};
        for(int i = 0; i < m; i++){
            for(int j = 0; j < n; j++){
                int alive = 0;
                for(int x = 0; x < 3; x++){
                    for(int y = 0; y < 3; y++){
                        if(bias[x] != 0 || bias[y] != 0){
                            int cur_i = i + bias[x], cur_j = j + bias[y];
                            if((cur_i >= 0 && cur_i < m) && (cur_j >= 0 && cur_j < n) && board[cur_i][cur_j] > 0){
                                alive++;
                            }
                        }
                    }
                }
                if(board[i][j] == 0 && alive == 3) board[i][j] = -1;
                if(board[i][j] == 1 && (alive < 2 || alive > 3)) board[i][j] = 2;
            }
        }
        for(int i = 0; i < m; i++){
            for(int j = 0; j < n; j++){
                if(board[i][j] == 2) board[i][j] = 0;
                else if(board[i][j] == -1) board[i][j] = 1;
            }
        }
    }
}
```