#### 8. 字符串转换整数 (atoi)

难度：中等

---

请你来实现一个 `myAtoi(string s)` 函数，使其能将字符串转换成一个 32 位有符号整数（类似 C/C++ 中的 `atoi` 函数）。

函数 `myAtoi(string s)` 的算法如下：

1.  读入字符串并丢弃无用的前导空格
2.  检查下一个字符（假设还未到字符末尾）为正还是负号，读取该字符（如果有）。 确定最终结果是负数还是正数。 如果两者都不存在，则假定结果为正。
3.  读入下一个字符，直到到达下一个非数字字符或到达输入的结尾。字符串的其余部分将被忽略。
4.  将前面步骤读入的这些数字转换为整数（即，"123" -> 123， "0032" -> 32）。如果没有读入数字，则整数为 `0` 。必要时更改符号（从步骤 2 开始）。
5.  如果整数数超过 32 位有符号整数范围 `[−2^31,  2^31 − 1]` ，需要截断这个整数，使其保持在这个范围内。具体来说，小于 `−2^31` 的整数应该被固定为 `−2^31` ，大于 `2^31 − 1` 的整数应该被固定为 `2^31 − 1` 。
6.  返回整数作为最终结果。

 **注意：** 

*   本题中的空白字符只包括空格字符 `' '` 。
*   除前导空格或数字后的其余字符串外， **请勿忽略**  任何其他字符。

 **示例 1：** 

```
输入：s = "42"
输出：42
解释：加粗的字符串为已经读入的字符，插入符号是当前读取的字符。
第 1 步："42"（当前没有读入字符，因为没有前导空格）
         ^
第 2 步："42"（当前没有读入字符，因为这里不存在 '-' 或者 '+'）
         ^
第 3 步："42"（读入 "42"）
           ^
解析得到整数 42 。
由于 "42" 在范围 [-231, 231 - 1] 内，最终结果为 42 。
```

 **示例 2：** 

```
输入：s = "   -42"
输出：-42
解释：
第 1 步："   -42"（读入前导空格，但忽视掉）
            ^
第 2 步："   -42"（读入 '-' 字符，所以结果应该是负数）
             ^
第 3 步："   -42"（读入 "42"）
               ^
解析得到整数 -42 。
由于 "-42" 在范围 [-231, 231 - 1] 内，最终结果为 -42 。
```

 **示例 3：** 

```
输入：s = "4193 with words"
输出：4193
解释：
第 1 步："4193 with words"（当前没有读入字符，因为没有前导空格）
         ^
第 2 步："4193 with words"（当前没有读入字符，因为这里不存在 '-' 或者 '+'）
         ^
第 3 步："4193 with words"（读入 "4193"；由于下一个字符不是一个数字，所以读入停止）
             ^
解析得到整数 4193 。
由于 "4193" 在范围 [-231, 231 - 1] 内，最终结果为 4193 。
```

 **提示：** 

*   `0 <= s.length <= 200`
*   `s` 由英文字母（大写和小写）、数字（`0-9`）、`' '`、`'+'`、`'-'` 和 `'.'` 组成

---

模拟题：使用队列来存放字符串中的有效数字。

算法流程：删除所有前导空格后，若当前字符为 `+` 或 `-` ，则改变结果的正负值并对下一个字符开始转换；若当前字符是数字，则直接开始转换；除上述两种情况外直接返回 `0`。

在转换的过程中，还需要删去前导零，当队列的容量大于 `10` 时，意味着肯定超过有符号整型范围，即 $-2147483648(2^{-31}) \sim 2147483648(2^{31} - 1)$，直接返回最大值或最小值。

```java
class Solution {
    public int myAtoi(String s) {
        ArrayDeque<Integer> queue = new ArrayDeque<>();
        long ans = 0;
        boolean pos = true;
        for(int i = 0; i < s.length(); i++){
            char c = s.charAt(i);
            if(c == ' ') continue;  // 删除前导空格
            if(c == '+' || c == '-'){   // 当前字符是正负号，则对下标加一并开始转换
                if(c == '-') pos = false;
                i++;
            }
            else if(Character.isDigit(c));  // 当前字符是数字，直接开始转换
            else return 0;  // 否则直接返回 0

            if(i >= s.length()) return 0;   // 下标加一后的特殊判断

            while(i < s.length() && s.charAt(i) == '0' && queue.isEmpty()) i++; // 删除前导零
            while(i < s.length() && Character.isDigit(s.charAt(i))){    //  开始转换
                queue.offer(s.charAt(i) - '0');
                if(queue.size() > 10) return pos == true ? Integer.MAX_VALUE : Integer.MIN_VALUE;   // 考虑到Integer.MAX_VALUE = 2147483647，队列容量大于10则说明数字一定大于整型。
                i++;
            }
            break;  // 转换结束直接退出
        }
        while(!queue.isEmpty()) ans = ans * 10 + queue.poll();
        ans *= pos == true ? 1 : -1;
        if(pos) return ans >= (long)Integer.MAX_VALUE ? Integer.MAX_VALUE : (int)ans;
        return ans <= (long)Integer.MIN_VALUE ? Integer.MIN_VALUE : (int)ans;
    }
}
```

