#### 438. 找到字符串中所有字母异位词

难度：中等

---

给定两个字符串 `s` 和 `p`，找到 `s` 中所有 `p` 的  **异位词**  的子串，返回这些子串的起始索引。不考虑答案输出的顺序。

 **异位词**  指由相同字母重排列形成的字符串（包括相同的字符串）。

 **示例 1:** 

```
输入: s = "cbaebabacd", p = "abc"
输出: [0,6]
解释:
起始索引等于 0 的子串是 "cba", 它是 "abc" 的异位词。
起始索引等于 6 的子串是 "bac", 它是 "abc" 的异位词。
```

  **示例 2:** 

```
输入: s = "abab", p = "ab"
输出: [0,1,2]
解释:
起始索引等于 0 的子串是 "ab", 它是 "ab" 的异位词。
起始索引等于 1 的子串是 "ba", 它是 "ab" 的异位词。
起始索引等于 2 的子串是 "ab", 它是 "ab" 的异位词。
```

 **提示:** 

*   `1 <= s.length, p.length <= 3 * 10^4`
*   `s` 和 `p` 仅包含小写字母

---

滑动窗口：

注意审题，在 `s` 中找所有 `p` 的子串。还有 `Arrays.equals(array1, array2)` 这个方法的使用来判断两个数组是否相同，不过也可以用数组遍历的方式替代。

以 `p` 为固定长度的数组在字符串 `s` 中进行滑动，每次滑动都进行相应的加减操作。

```Java
class Solution {
    public List<Integer> findAnagrams(String s, String p) {
        if(s.length() < p.length()) return new ArrayList<Integer>();
        int[] sCount = new int[26], pCount = new int[26];
        List<Integer> ans = new ArrayList<>();
        for(int i = 0; i < p.length(); i++){
            sCount[s.charAt(i) - 'a']++;
            pCount[p.charAt(i) - 'a']++;
        }
        if(Arrays.equals(sCount, pCount)){
            ans.add(0);
        }
        for(int i = 0; i < s.length() - p.length(); i++){	// 滑动
            sCount[s.charAt(i) - 'a']--;
            sCount[s.charAt(i + p.length()) - 'a']++;
            if(Arrays.equals(sCount, pCount)){
                ans.add(i + 1);
            }
        }
        return ans;
    }
}
```