#### 912. 排序数组

难度：中等

---

给你一个整数数组 `nums`，请你将该数组升序排列。

 **示例 1：** 

```
输入：nums = [5,2,3,1]
输出：[1,2,3,5]
```

 **示例 2：** 

```
输入：nums = [5,1,1,2,0,0]
输出：[0,0,1,1,2,5]
```

 **提示：** 

*   `1 <= nums.length <= 5 * 10^4`
*   `-5 * 10^4 <= nums[i] <= 5 * 10^4`

---

堆排序分为两部分，**建堆**和**交换头尾节点的值并调整堆**。升序则建最大堆，降序则建最小堆。

这两部分都需要用到同一个方法，即向下交换数据。

向下交换数据的过程是选取叶子节点的最大/小值（分别对应建最大/小堆），判断是否大/小于父亲节点的值，如果大/小于则交换。也要考虑右子节点不存在的情况，此时只需要判断左子节点即可。

- 在建堆部分，从下标  `(n - 2) / 2` 遍历至零，因为叶子节点有 `(n + 1) / 2` 个，这些叶子节点不需要向下交换的。

- 在交换头尾节点的值并调整堆的部分，交换后，整个数组的范围应该减一，并且头节点（下标为零）需要向下交换数据。

```java
class Solution {
    public int[] sortArray(int[] nums) {
        int n = nums.length;
        buildMaxHeap(nums, n);
        for(int i = n; i > 0;){
            swap(nums, 0, i - 1);
            i--;
            bottomUp(nums, 0, i);
        }
        return nums;
    }

    private void buildMaxHeap(int[] nums, int n){
        for(int i = (n - 2) / 2; i >= 0 ; i--){
            bottomUp(nums, i, n);
        }
    }

    private void bottomUp(int[] nums, int i, int n){
        while(2 * i + 1 < n){
            int left = 2 * i + 1, right = left + 1, index = left;
            if(right < n && nums[right] > nums[left]) index = right;
            if(nums[index] > nums[i]) swap(nums, index, i);
            else break;
            i = index;
        }
    }

    private void swap(int[] nums, int i, int j){
        int temp = nums[i];
        nums[i] = nums[j];
        nums[j] = temp;
    }
}
```