#### 912. 排序数组

难度：中等

---

给你一个整数数组 `nums`，请你将该数组升序排列。

 **示例 1：** 

```
输入：nums = [5,2,3,1]
输出：[1,2,3,5]
```

 **示例 2：** 

```
输入：nums = [5,1,1,2,0,0]
输出：[0,0,1,1,2,5]
```

 **提示：** 

*   `1 <= nums.length <= 5 * 10^4`
*   `-5 * 10^4 <= nums[i] <= 5 * 10^4`

---

普通的归并排序：

```java
class Solution {
    public int[] sortArray(int[] nums) {
        merge(nums, 0, nums.length - 1);
        return nums;
    }

    private void merge(int[] nums, int left, int right){
        if(left < right){
            int mid = (left + right) / 2;
            merge(nums, left, mid);
            merge(nums, mid + 1, right);
            mergeSort(nums, left, mid, right);
        }
    }

    private void mergeSort(int[] nums, int left, int mid, int right){
        int i = left, j = mid + 1, index = 0;
        int[] temp = new int[right - left + 1];
        while(i <= mid && j <= right){
            if(nums[i] <= nums[j]){
                temp[index++] = nums[i++];
            }
            else {
                temp[index++] = nums[j++];
            }
        }
        while(i <= mid) temp[index++] = nums[i++];
        while(j <= right) temp[index++] = nums[j++];
        System.arraycopy(temp, 0, nums, left, right - left + 1);
    }
}
```



优化后的归并排序有以下两个优化点：

1. 区间范围小于 `INSERTION_SORT_THRESHOLD` 的数组使用插入排序
2. 左数组的最后一个数小于或等于右数组的第一个数，证明已经有序

```java
class Solution {
    private static final int INSERTION_SORT_THRESHOLD = 7;

    public int[] sortArray(int[] nums) {
        merge(nums, 0, nums.length - 1);
        return nums;
    }

    private void merge(int[] nums, int left, int right){
        if (right - left <= INSERTION_SORT_THRESHOLD) {	// 优化点 1
            insertionSort(nums, left, right);
            return;
        }
        int mid = (left + right) >>> 1;
        merge(nums, left, mid);
        merge(nums, mid + 1, right);
        if(nums[mid] <= nums[mid + 1]) return;	// 优化点 2
        mergeSort(nums, left, mid, right);
    }

    private void insertionSort(int[] nums, int left, int right) {
        for (int i = left + 1; i <= right; i++) {
            int temp = nums[i], j = i;
            while (j > left && nums[j - 1] > temp) {
                nums[j] = nums[j - 1];
                j--;
            }
            nums[j] = temp;
        }
    }

    private void mergeSort(int[] nums, int left, int mid, int right){
        int i = left, j = mid + 1, index = 0;
        int[] temp = new int[right - left + 1];
        while(i <= mid && j <= right){
            if(nums[i] <= nums[j]){
                temp[index++] = nums[i++];
            }else{
                temp[index++] = nums[j++];
            }
        }
        while(i <= mid) temp[index++] = nums[i++];
        while(j <= right) temp[index++] = nums[j++];
        System.arraycopy(temp, 0, nums, left, right - left + 1);
    }
}
```

