#### 912. 排序数组

难度：中等

---

给你一个整数数组 `nums`，请你将该数组升序排列。

 **示例 1：** 

```
输入：nums = [5,2,3,1]
输出：[1,2,3,5]
```

 **示例 2：** 

```
输入：nums = [5,1,1,2,0,0]
输出：[0,0,1,1,2,5]
```

 **提示：** 

*   `1 <= nums.length <= 5 * 10^4`
*   `-5 * 10^4 <= nums[i] <= 5 * 10^4`

---

**朴素的快速排序：**

需要注意的是在区间中寻找大于或小于基准值时，因为基准值选取的是最左侧，所以要从右边开始向左找！

```java
class Solution {
    public int[] sortArray(int[] nums) {
        quickSort(nums, 0, nums.length - 1);
        return nums;
    }

    private void quickSort(int[] nums, int left, int right){
        if(right <= left) return;
        // int index = new Random().nextInt(right - left + 1) + left; // 随机选取下标并与最左侧元素交换，优化点1
        // swap(nums, left, index);
        int pivot = findPivot(nums, left, right);
        quickSort(nums, left, pivot - 1);
        quickSort(nums, pivot + 1, right);
    }

    private int findPivot(int[] nums, int left, int right){
        int index = left, temp = nums[left];
        while(left < right){
            while(left < right && nums[right] >= temp) right--;	// 要先从右边开始找！
            while(left < right && nums[left] <= temp) left++;
            if(left < right) swap(nums, left, right);
        }
        swap(nums, index, left);
        return left;
    }
    private void swap(int[] nums, int i, int j){
        int temp = nums[i];
        nums[i] = nums[j];
        nums[j] = temp;
    }
}
```



**快速排序的优化方法：**

1. **选取随机基准点**并与最左侧的数（第一个数）**交换**位置，始终选择最左侧的数（第一个数）为基准点则会超时。交换也是需要的，因为循环结束后 `nums[left]` 一定小于或等于基准点的数，又因为基准点是随机的，因此无法确定 `left` 与基准点的大小关系。

2. **三路快排**，在**大量重复数据**的数组中，该优化后的效果特别明显。简单来说是将区间分为**小于**，**等于**和**大于**三段，接着递归排序小于和大于的两段区间。

```java
class Solution {
    public int[] sortArray(int[] nums) {
        quickSort(nums, 0, nums.length - 1);
        return nums;
    }

    private void quickSort(int[] nums, int left, int right){
        if(right <= left) return;
        int index = new Random().nextInt(right - left + 1) + left;		// 随机选取下标并与最左侧元素交换，优化点1
        swap(nums, left, index);

        int lt = left, i = left + 1, gt = right + 1;
        while(i < gt){
            if(nums[i] < nums[left]){
                swap(nums, ++lt, i++);
            }else if(nums[i] > nums[left]){
                swap(nums, i, --gt);
            }else{
                i++;
            }
        }
        swap(nums, left, lt);
        // nums[left , lt-1] < v , nums[lt , gt-1] == v ,nums[gt , right] > v

        quickSort(nums, left, lt - 1);
        quickSort(nums, gt, right);
    }


    private void swap(int[] nums, int i, int j){
        int temp = nums[i];
        nums[i] = nums[j];
        nums[j] = temp;
    }
}
```

