#### 155. 最小栈

难度：中等

---

设计一个支持 `push` ，`pop` ，`top` 操作，并能在常数时间内检索到最小元素的栈。

实现 `MinStack` 类:

*   `MinStack()` 初始化堆栈对象。
*   `void push(int val)` 将元素val推入堆栈。
*   `void pop()` 删除堆栈顶部的元素。
*   `int top()` 获取堆栈顶部的元素。
*   `int getMin()` 获取堆栈中的最小元素。

 **示例 1:** 

```
输入：
["MinStack","push","push","push","getMin","pop","top","getMin"]
[[],[-2],[0],[-3],[],[],[],[]]

输出：
[null,null,null,null,-3,null,0,-2]

解释：
MinStack minStack = new MinStack();
minStack.push(-2);
minStack.push(0);
minStack.push(-3);
minStack.getMin();   --> 返回 -3.
minStack.pop();
minStack.top();      --> 返回 0.
minStack.getMin();   --> 返回 -2.
```

 **提示：** 

*   `-2^31 <= val <= 2^31 - 1`
*   `pop`、`top` 和 `getMin` 操作总是在  **非空栈**  上调用
*   `push`, `pop`, `top`, and `getMin`最多被调用 `3 * 10^4` 次

---

栈：

使用辅助栈，其元素的值为原栈中的最小值。在初始化阶段向辅助栈中注入最大值元素，以便空栈情况下的判断。

```Java
class MinStack {

    ArrayDeque<Integer> stack, minStack;

    public MinStack() {
        stack = new ArrayDeque<>();
        minStack = new ArrayDeque<>();
        minStack.push(Integer.MAX_VALUE);
    }
    
    public void push(int val) {
        stack.push(val);
        minStack.push(Math.min(minStack.peek(), val));
    }
    
    public void pop() {
        stack.pop();
        minStack.pop();
    }
    
    public int top() {
        return stack.peek();
    }
    
    public int getMin() {
        return minStack.peek();
    }
}

/**
 * Your MinStack object will be instantiated and called as such:
 * MinStack obj = new MinStack();
 * obj.push(val);
 * obj.pop();
 * int param_3 = obj.top();
 * int param_4 = obj.getMin();
 */
```