#### 1023. 驼峰式匹配

难度：中等

---

如果我们可以将 **小写字母** 插入模式串 `pattern` 得到待查询项 `query`，那么待查询项与给定模式串匹配。（我们可以在任何位置插入每个字符，也可以插入 0 个字符。）

给定待查询列表 `queries`，和模式串 `pattern`，返回由布尔值组成的答案列表 `answer`。只有在待查项 `queries[i]` 与模式串 `pattern` 匹配时， `answer[i]` 才为 `true`，否则为 `false`。

 **示例 1：** 

```
输入：queries = ["FooBar","FooBarTest","FootBall","FrameBuffer","ForceFeedBack"], pattern = "FB"
输出：[true,false,true,true,false]
示例：
"FooBar" 可以这样生成："F" + "oo" + "B" + "ar"。
"FootBall" 可以这样生成："F" + "oot" + "B" + "all".
"FrameBuffer" 可以这样生成："F" + "rame" + "B" + "uffer".
```

 **示例 2：** 

```
输入：queries = ["FooBar","FooBarTest","FootBall","FrameBuffer","ForceFeedBack"], pattern = "FoBa"
输出：[true,false,true,false,false]
解释：
"FooBar" 可以这样生成："Fo" + "o" + "Ba" + "r".
"FootBall" 可以这样生成："Fo" + "ot" + "Ba" + "ll".
```

 **示例 3：** 

```
输入：queries = ["FooBar","FooBarTest","FootBall","FrameBuffer","ForceFeedBack"], pattern = "FoBaT"
输出：[false,true,false,false,false]
解释： 
"FooBarTest" 可以这样生成："Fo" + "o" + "Ba" + "r" + "T" + "est".
```

 **提示：** 

1.  `1 <= queries.length <= 100`
2.  `1 <= queries[i].length <= 100`
3.  `1 <= pattern.length <= 100`
4.  所有字符串都仅由大写和小写英文字母组成。

---

双指针：

第一个指针 `c1 = queries[i].charAt(first)`，另一个指针 `c2 = pattern.charAt(second)`， 分四种情况：

1. `c1` 和 `c2` 均为大写；
2. `c1` 和 `c2` 均为小写；
3. `c1` 小写，`c2` 大写；
4. `c1` 大写，`c2` 小写；

遍历结束后，如果第一个指针没有超出范围，则继续遍历第一个字符串，如果后续存在大写字母，则此次查询结果为 `false`。

如果第二个指针没有超出范围，意味着第一个字符串里有第二个字符串没有的字符，因此此次查询结果为 `false`。

```Java
class Solution {
    public List<Boolean> camelMatch(String[] queries, String pattern) {
        List<Boolean> ans = new ArrayList<>();
        for(int i = 0; i < queries.length; i++){
            boolean flag = true;
            int first = 0, second = 0;
            while(first < queries[i].length() && second < pattern.length()){
                char c1 = queries[i].charAt(first), c2 = pattern.charAt(second);
                if(Character.isUpperCase(c1) && Character.isUpperCase(c2)){
                    if(c1 == c2){
                        first++;
                        second++;
                    } else {
                        flag = false;
                        break;
                    }
                }
                else if(Character.isLowerCase(c1) && Character.isLowerCase(c2)){
                    first++;
                    if(c1 == c2) second++;
                }
                else if(Character.isLowerCase(c1) && Character.isUpperCase(c2)){
                    first++;
                } else {
                    flag = false;
                    break;
                }
            }
            while(first < queries[i].length()){
                char c1 = queries[i].charAt(first);
                if(Character.isUpperCase(c1)){
                    flag = false;
                    break;
                }
                first++;
            }
            if(second < pattern.length()){
                flag = false;
            }
            ans.add(flag);
        }
        return ans;
    }
}
```