#### 15. 三数之和

难度：中等

---

给你一个整数数组 `nums` ，判断是否存在三元组 `[nums[i], nums[j], nums[k]]` 满足 `i != j`、`i != k` 且 `j != k` ，同时还满足 `nums[i] + nums[j] + nums[k] == 0` 。请

你返回所有和为 `0` 且不重复的三元组。

 **注意：** 答案中不可以包含重复的三元组。

 **示例 1：** 

```
输入：nums = [-1,0,1,2,-1,-4]
输出：[[-1,-1,2],[-1,0,1]]
解释：
nums[0] + nums[1] + nums[2] = (-1) + 0 + 1 = 0 。
nums[1] + nums[2] + nums[4] = 0 + 1 + (-1) = 0 。
nums[0] + nums[3] + nums[4] = (-1) + 2 + (-1) = 0 。
不同的三元组是 [-1,0,1] 和 [-1,-1,2] 。
注意，输出的顺序和三元组的顺序并不重要。
```

 **示例 2：** 

```
输入：nums = [0,1,1]
输出：[]
解释：唯一可能的三元组和不为 0 。
```

 **示例 3：** 

```
输入：nums = [0,0,0]
输出：[[0,0,0]]
解释：唯一可能的三元组和为 0 。
```

 **提示：** 

*   `3 <= nums.length <= 3000`
*   `-10^5 <= nums[i] <= 10^5`

---

排序 + 双指针：首先固定第一个指针位置，在第一个指针从头到尾遍历的每个情况下再固定一个左指针和右指针。三个指针的值相加再与目标值进行比较。通过比较大小关系进行左右指针向右向左移动的操作。

本题的关键在于如何去除重复解。在求解过程中用到了三个指针，去除重复解也正是利用三个指针的移动。

- 第一个指针：与上一个指针的值相同时，跳过当前指针
- 左右指针：与下一个指针的值相同时，跳过接下来的指针

```java
class Solution {
    public List<List<Integer>> threeSum(int[] nums) {
        List<List<Integer>> ans = new ArrayList();
        if(nums.length < 3) return ans;
        Arrays.sort(nums);
        for(int i = 0; i < nums.length - 2; i++){
            if(nums[i] > 0) break;
            if(i > 0 && nums[i] == nums[i - 1]) continue;
            int left = i + 1, right = nums.length - 1;
            while(left < right){
                int sum = nums[i] + nums[left] + nums[right];
                if(sum == 0){
                    ans.add(Arrays.asList(nums[i], nums[left], nums[right]));
                    while(left < right && nums[left] == nums[left + 1]) left++;
                    while(left < right && nums[right] == nums[right - 1]) right--;
                    left++;
                    right--;
                }
                else if(sum < 0) left++;
                else right--;
            }
        }
        return ans;
    }
}
```

