#### 1616. 分割两个字符串得到回文串

难度：中等

---

给你两个字符串 `a` 和 `b` ，它们长度相同。请你选择一个下标，将两个字符串都在  **相同的下标**  分割开。由 `a` 可以得到两个字符串： `aprefix` 和 `asuffix` ，满足 `a = aprefix + asuffix` ，同理，由 `b` 可以得到两个字符串 `bprefix` 和 `bsuffix` ，满足 `b = bprefix + bsuffix` 。请你判断 `aprefix + bsuffix` 或者 `bprefix + asuffix` 能否构成回文串。

当你将一个字符串 `s` 分割成 `sprefix` 和 `ssuffix` 时， `ssuffix` 或者 `sprefix` 可以为空。比方说， `s = "abc"` 那么 `"" + "abc"` ， `"a" + "bc"` ， `"ab" + "c"` 和 `"abc" + ""` 都是合法分割。

如果  **能构成回文字符串**  ，那么请返回 `true`，否则返回 `false` 。

 **注意** ， `x + y` 表示连接字符串 `x` 和 `y` 。

 **示例 1：** 

```
输入：a = "x", b = "y"
输出：true
解释：如果 a 或者 b 是回文串，那么答案一定为 true ，因为你可以如下分割：
aprefix = "", asuffix = "x"
bprefix = "", bsuffix = "y"
那么 aprefix + bsuffix = "" + "y" = "y" 是回文串。
```

 **示例 2：** 

```
输入：a = "abdef", b = "fecab"
输出：true
```

 **示例 3：** 

```
输入：a = "ulacfd", b = "jizalu"
输出：true
解释：在下标为 3 处分割：
aprefix = "ula", asuffix = "cfd"
bprefix = "jiz", bsuffix = "alu"
那么 aprefix + bsuffix = "ula" + "alu" = "ulaalu" 是回文串。
```

 **提示：** 

*   `1 <= a.length, b.length <= 10^5`
*   `a.length == b.length`
*   `a` 和 `b` 都只包含小写英文字母

---

双指针：

1. 用两个指针分别表示字符串A的前缀与字符串B的后缀在哪个下标位置不构成回文字符串（另一种情况是A的后缀和B的前缀，因此用逻辑运算符**或**连接这两种情况的返回值）。对于下列字符串，当A的下标为4和B的下标为17时（字符串A下标在0-3与字符串B下标在18-21时可组成回文字符串）。
2. 接着判断字符串A和B在这两个下标之间是否构成回文字符串，任意一个字符串满足条件则返回true，否则返回false。对于下列字符串，字符串B在下标4-17之间是回文，因此返回true。



![](https://raw.githubusercontent.com/CompetitiveLin/ImageHostingService/picgo/imgs/202303181157470.png)

```Java
class Solution {
    public boolean checkPalindromeFormation(String a, String b) {
        return checkConcatenation(a, b) || checkConcatenation(b, a);
    }
    private boolean checkConcatenation(String a, String b){
        int n = a.length(), left = 0, right = n - 1;
        while(left < right && a.charAt(left) == b.charAt(right)){
            left++;
            right--;
        }
        if(left >= right) return true;
        return checkSelfPalindrome(a, left, right) || checkSelfPalindrome(b, left, right);
    }
    private boolean checkSelfPalindrome(String s, int left, int right){
        while(left < right){
            if(s.charAt(left++) != s.charAt(right--)) return false;
        }
        return true;
    }
}
```