#### 18. 四数之和

难度：中等

---

给你一个由 `n` 个整数组成的数组 `nums` ，和一个目标值 `target` 。请你找出并返回满足下述全部条件且 **不重复** 的四元组 `[nums[a], nums[b], nums[c], nums[d]]` （若两个四元组元素一一对应，则认为两个四元组重复）：

*   `0 <= a, b, c, d < n`
*   `a`、`b`、`c` 和 `d`  **互不相同** 
*   `nums[a] + nums[b] + nums[c] + nums[d] == target`

你可以按  **任意顺序**  返回答案 。

 **示例 1：** 

```
输入：nums = [1,0,-1,0,-2,2], target = 0
输出：[[-2,-1,1,2],[-2,0,0,2],[-1,0,0,1]]
```

 **示例 2：** 

```
输入：nums = [2,2,2,2,2], target = 8
输出：[[2,2,2,2]]
```

 **提示：** 

*   `1 <= nums.length <= 200`
*   `-10^9 <= nums[i] <= 10^9`
*   `-10^9 <= target <= 10^9`

---

与[15. 三数之和](./15.%20%E4%B8%89%E6%95%B0%E4%B9%8B%E5%92%8C.md)类似，只是又多了一个指针。

总共是四个指针，分别是头指针、尾指针、左指针、右指针。

关键也是**去除重复解**。

不过这里额外需要注意的是**越界**的问题。需要转换成 `Long` 类型进行对比，或者用**相减**的方法。


```java
class Solution {
    public List<List<Integer>> fourSum(int[] nums, int target) {
        Arrays.sort(nums);
        List<List<Integer>> ans = new ArrayList();
        for(int a = 0; a < nums.length - 3; a++){
            if(a > 0 && nums[a] == nums[a - 1]) continue;
            for(int d = nums.length - 1; d > a + 2; d--){
                if(d < nums.length - 1 && nums[d] == nums[d + 1]) continue;
                int b = a + 1, c = d - 1;
                while(b < c){
                    long sum = (long)nums[a] + nums[b] + nums[c] + nums[d];
                    if(sum == target){
                        ans.add(Arrays.asList(nums[a], nums[b], nums[c], nums[d]));
                        while(b < c && nums[b] == nums[b + 1]) b++;
                        b++;
                        while(b < c && nums[c] == nums[c - 1]) c--;
                        c--;
                    }
                    else if(sum < target){
                        while(b < c && nums[b] == nums[b + 1]) b++;
                        b++;
                    }
                    else{
                        while(b < c && nums[c] == nums[c - 1]) c--;
                        c--;
                    }
                }
            }
        }
        return ans;
    }
}
```

