#### 1813. 句子相似性 III

难度：中等

---

一个句子是由一些单词与它们之间的单个空格组成，且句子的开头和结尾没有多余空格。比方说，`"Hello World"` ，`"HELLO"` ，`"hello world hello world"` 都是句子。每个单词都  **只**  包含大写和小写英文字母。

如果两个句子 `sentence1` 和 `sentence2` ，可以通过往其中一个句子插入一个任意的句子（ **可以是空句子** ）而得到另一个句子，那么我们称这两个句子是  **相似的**  。比方说，`sentence1 = "Hello my name is Jane"` 且 `sentence2 = "Hello Jane"` ，我们可以往 `sentence2` 中 `"Hello"` 和 `"Jane"` 之间插入 `"my name is"` 得到 `sentence1` 。

给你两个句子 `sentence1` 和 `sentence2` ，如果 `sentence1` 和 `sentence2` 是相似的，请你返回 `true` ，否则返回 `false` 。

 **示例 1：** 

```
输入：sentence1 = "My name is Haley", sentence2 = "My Haley"
输出：true
解释：可以往 sentence2 中 "My" 和 "Haley" 之间插入 "name is" ，得到 sentence1 。
```

 **示例 2：** 

```
输入：sentence1 = "of", sentence2 = "A lot of words"
输出：false
解释：没法往这两个句子中的一个句子只插入一个句子就得到另一个句子。
```

 **示例 3：** 

```
输入：sentence1 = "Eating right now", sentence2 = "Eating"
输出：true
解释：可以往 sentence2 的结尾插入 "right now" 得到 sentence1 。
```

 **示例 4：** 

```
输入：sentence1 = "Luky", sentence2 = "Lucccky"
输出：false
```

 **提示：** 

*   `1 <= sentence1.length, sentence2.length <= 100`
*   `sentence1` 和 `sentence2` 都只包含大小写英文字母和空格。
*   `sentence1` 和 `sentence2` 中的单词都只由单个空格隔开。

---

双指针：

在 `sentence1` 比 `sentence2` 短的前提下，先将两个字符串以空格作为分界符划分成两个数组，利用两个指针分别代表 `sentence1` 数组的从前向后遍历的长度和从后向前遍历的长度。不管是从前向后还是从后向前遍历，如果对应遍历方式的单词相同，则长度增加一个单位，最后判断两者长度相加是否等于 `sentence1` 的单词数。

```java
class Solution {
    public boolean areSentencesSimilar(String sentence1, String sentence2) {
        if(sentence1.length() > sentence2.length()){
            String temp = sentence1;
            sentence1 = sentence2;
            sentence2 = temp;
        }
        String[] s1 = sentence1.split(" ");
        String[] s2 = sentence2.split(" ");
        int i = 0, j = 0, min = s1.length;
        while(i < min && s1[i].equals(s2[i])) i++;
        while(j < min - i && s1[s1.length - 1 - j].equals(s2[s2.length - 1 - j])) j++;
        return i + j == min;
    }
}
```