#### 19. 删除链表的倒数第 N 个结点

难度：中等

---

给你一个链表，删除链表的倒数第 `n` 个结点，并且返回链表的头结点。

 **示例 1：** 

![](https://assets.leetcode.com/uploads/2020/10/03/remove_ex1.jpg)
```
输入：head = [1,2,3,4,5], n = 2
输出：[1,2,3,5]
```

 **示例 2：** 

```
输入：head = [1], n = 1
输出：[]
```

 **示例 3：** 

```
输入：head = [1,2], n = 1
输出：[1]
```

 **提示：** 

*   链表中结点的数目为 `sz`
*   `1 <= sz <= 30`
*   `0 <= Node.val <= 100`
*   `1 <= n <= sz`

 **进阶：** 你能尝试使用一趟扫描实现吗？

---

[动画图解 LeetCode 第 19 号问题：删除链表的倒数第 N 个节点](https://leetcode.cn/problems/remove-nth-node-from-end-of-list/solution/dong-hua-tu-jie-leetcode-di-19-hao-wen-ti-shan-chu/)

一次遍历：构造一个虚拟节点指向头节点，前指针指向该虚拟节点，后指针指向虚拟节点向后移动 `N + 1` 个位置的节点，同时移动这两个指针，直到后指针指向空节点。此时前指针指向的节点就是需要删除的节点的前节点。

**构造虚拟节点是因为有可能会删除第一个节点。**

```java
/**
 * Definition for singly-linked list.
 * public class ListNode {
 *     int val;
 *     ListNode next;
 *     ListNode() {}
 *     ListNode(int val) { this.val = val; }
 *     ListNode(int val, ListNode next) { this.val = val; this.next = next; }
 * }
 */
class Solution {
    public ListNode removeNthFromEnd(ListNode head, int n) {
        ListNode dummy = new ListNode(), start = dummy, end = dummy;
        dummy.next = head;
        while(n-- != -1){   // 移动 n + 1 次
            end = end.next;
        }
        while(end != null){
            start = start.next;
            end = end.next;
        }
        start.next = start.next.next;
        return dummy.next;
    }
}
```